#ifndef miscHash_H
#define miscHash_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: miscHash.h,v 1.1 2007/02/26 14:51:42 cguirao Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  13/10/95  Created
*/

/************************************************************************
 * Header File for the MISC Hash Function
 *----------------------------------------------------------------------
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NOCCS
    #include "ccs.h"
#else
    #include "miscNoCcs.h"
#endif

/* Macro definitions
 */
#define miscNO_OF_HASH_ELS  2500


/* Type declarations
 */
typedef struct miscHASH_ELEMENT {
    struct miscHASH_ELEMENT  *next;
    void                     *element;
    char                     *key;
} miscHASH_EL;

typedef miscHASH_EL  *miscHASH_TABLE[miscNO_OF_HASH_ELS];


/* Function prototyping
 */
void miscHashInit(miscHASH_TABLE  hashTable);

ccsCOMPL_STAT miscHashAddElement(miscHASH_TABLE  hashTable,
				 const char      *key,
				 void            **element,
				 ccsERROR        *error);

void miscHashDeleteTable(miscHASH_TABLE  hashTable);

ccsCOMPL_STAT miscHashDeleteEl(miscHASH_TABLE  hashTable,
			       const char      *key,
			       ccsERROR        *error);

ccsCOMPL_STAT miscHashNullElPtr(miscHASH_TABLE  hashTable,
				const char      *key,
				ccsERROR        *error);

ccsCOMPL_STAT miscHashGetEl(const miscHASH_TABLE  hashTable,
			    const char            *key,
			    void                  **element,
			    ccsERROR              *error);

ccsCOMPL_STAT miscHashGetSeq(const miscHASH_TABLE  hashTable,
			     const vltLOGICAL      initialize,
			     void                  **element,
			     ccsERROR              *error);

void miscDumpTable(const miscHASH_TABLE  hashTable);

ccsCOMPL_STAT miscHashGetHashKey(miscHASH_TABLE  hashTable,
				 void            *element,
				 char            *hashKey,
				 ccsERROR        *error);

/* VLTSW20010618 'public' function to check if hashtable is dictionary
 */
vltLOGICAL   miscIsDictionary(const miscHASH_TABLE  hashTable); 

    
ccsCOMPL_STAT miscHashGetElExact(const miscHASH_TABLE  hashTable,
				 const char            *key,
				 void                  **element,
				 ccsERROR              *error);

#ifdef __cplusplus
}
#endif

#endif /*!miscHash_H*/
