#ifndef oslxUtils_H
#define oslxUtils_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: oslxUtils.h,v 1.1 2007/02/26 14:51:42 cguirao Exp $" 
*
* oslxUtils.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  26/09/95  created 
* epozna    17/04/03  VLTSW20020388 (b) added  slxCreStoreShFitsDicBufSpec
*/

/************************************************************************
*  Header file for the OSLX Projects Utilities
*
*  IT IS STRICTLY FORBIDDEN TO USE THE FUNCTIONS IN THIS FILE!!
*  THEY ARE NOT RELEASED AND THEY MAY CHANGE!
*
*----------------------------------------------------------------------
*/
#ifndef __cplusplus
#error This is a C++ include file which cannot be used from plain C
#endif

#include "oslx.h"


char *slxGetTrueFalse(vltLOGICAL  state);

void oslxParInfo(char *par, char *cmdBuf);

ccsCOMPL_STAT slxConfigTypeStr2No(const char      *configTypeStr,
				  slxCONFIG_TYPE  *configType,
				  ccsERROR        *error);

ccsCOMPL_STAT slxConfigNo2Str(const slxCONFIG_TYPE  configType,
			      slxKEYW_LINE          configTypeStr,
			      ccsERROR              *error);

ccsCOMPL_STAT slxMakeSetupFileName(slxFILENAME       fileName,
				   miscHASH_TABLE    pafHeaderHashTable, 
				   ccsERROR          *error);

ccsCOMPL_STAT slxCreatePafFileBuf(slxDYN_BUF        *setupBuf,
				  miscHASH_TABLE    pafHeaderHashTable, 
				  slxCHANGE_RECORD  pafChangeRecord,
				  miscHASH_TABLE    dictionary,
				  const vltLOGICAL  saveComments,
				  vltINT32          includeCount,
				  vltINT32          dataBlockCount,
				  ccsERROR          *error);

ccsCOMPL_STAT slxCreStoreShFitsDicBuf2(slxDYN_BUF      *setupBuf,
				       slxCATEGORY     category,
				       slxSUBSYSTEM    subSystem1,
				       slxSUBSYSTEM    subSystem2,
				       slxPARAMETER    parameter,
				       slxFITS_VALUE   value,
				       miscHASH_TABLE  dictionary,
				       ccsERROR        *error);

ccsCOMPL_STAT slxCreStoreShFitsDicBuf3(slxDYN_BUF      *pafBuf,
				       slxKEYW_LINE    keyword,
				       slxFITS_VALUE   value,
				       miscHASH_TABLE  dictionary,
				       ccsERROR        *error);

//VLTSW20020388
ccsCOMPL_STAT slxCreStoreShFitsDicBufSpec(slxDYN_BUF      *pafBuf,
					  slxKEYW_LINE    keyword,
					  slxFITS_VALUE   value,
					  char *          longval,
					  miscHASH_TABLE  dictionary,
					  ccsERROR        *error);
ccsCOMPL_STAT slxMakeSetupMsgBufList(slxKEYW_INFO       *keywordList,
				     slxCHANGE_RECORD   changeRecord,
				     slxSETUP_FLAGS     *setupFlags,
				     slxDYN_BUF         *msgBuf,
				     ccsERROR           *error);

ccsCOMPL_STAT slxSetChangeRecord(slxCHANGE_RECORD   changeRecord,
				 vltUINT16          elementNo,
				 ccsERROR           *error);

ccsCOMPL_STAT slxSetupTypeStr2No(slxKEYW_LINE   setupType,
				 slxSETUP_TYPE  *setupTypeNo,
				 ccsERROR       *error);

ccsCOMPL_STAT slxSetupTypeNo2Str(slxSETUP_TYPE  setupTypeNo,
				 slxKEYW_LINE   setupType,
				 ccsERROR       *error);

ccsCOMPL_STAT slxCreStoreFitsDicBuf2(slxDYN_BUF      *setupBuf,
				     slxCATEGORY     category,
				     slxSUBSYSTEM    subSystem,
				     slxSUBSYSTEM    subSystem2,
				     slxPARAMETER    parameter,
				     slxFITS_VALUE   value,
				     miscHASH_TABLE  dictionary,
				     ccsERROR        *error);

ccsCOMPL_STAT slxClearFITSHeader(slxFILENAME fileName,
				 vltUINT8    noOfBlocks, 
				 vltLOGICAL  writeEND, 
				 ccsERROR    *error);

ccsCOMPL_STAT oslxCreStoreFITSDicBuf3(oslxDYN_BUF     &headerBuf,
				      slxKEYW_INFO    *keywInfo,
				      miscHASH_TABLE  dictionary,
				      ccsERROR        *error);

ccsCOMPL_STAT slxInsertElement(slxKEYW_INFO    *newEl, 
			       slxKEYW_INFO    *destList, 
			       ccsERROR        *error);

ccsCOMPL_STAT slxNoOfFitsBlocks(slxFILENAME   fileName,
				vltINT32      *noOfBlocks,
				ccsERROR      *error);


ccsCOMPL_STAT slxExtendFitsHeader(slxFILENAME  fileName,
				  vltINT32     noOfBlocks,
				  vltLOGICAL   writeEnd,
				  vltLOGICAL   blankHeader,
				  ccsERROR     *error);

vltINT32 slxSumUpChRec(slxCHANGE_RECORD changeRecord);

ccsCOMPL_STAT slxBuildImageFileName(const slxFILENAME  fileName,
				    const vltLOGICAL   addExt,
				    slxFILENAME        completeName,
				    ccsERROR           *error);

ccsCOMPL_STAT slxMatchString(char       *needle, 
			     char       *hayStack,
			     vltLOGICAL *match,
			     ccsERROR   *error);

void slxYankSemicolon(slxKEYW_LINE  keyword);

void slxFreeKeywordList(const slxKEYW_INFO  *keywordList);

void slxDelMemKeyInfoStr(slxKEYW_INFO  *keyInfo);

ccsCOMPL_STAT slxLoadDicHeader(const slxDICTIONARY dictionary,
			       slxDYN_BUF          *dynBuf,
			       ccsERROR            *error);

ccsCOMPL_STAT slxInsFileInfo(const slxFILENAME completeName,
			     slxFILENAME       path,
			     slxFILENAME       user,
			     slxFILENAME       modeDir,
			     slxFILENAME       fileName,
			     slxFILENAME       extension,
			     slxFILENAME       size,
			     slxFILENAME       time,
			     slxFILENAME       date,
			     slxFILENAME       permissions,
			     vltLOGICAL        useInsTree,
			     ccsERROR          *error);

int oslxPutEnv(char  *envVar);


// For the OSLX Servers
ccsCOMPL_STAT oslxCheckXPar(vltINT32  cmdNo, 
			    vltINT32  minNo, 
			    char      *errText,
			    ccsERROR  *error);

ccsCOMPL_STAT _oslxCmdStr2No(const char  *cmdStr,
			     oslxCMD     *cmdNo,
			     ccsERROR    *error);


#endif /*!oslxUtils_H*/


