#ifndef slxFits_H
#define slxFits_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: slxFits.h,v 1.1 2007/02/26 14:51:42 cguirao Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  04/10/96  created
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifdef __cplusplus
extern "C" {
#endif

#include "slxBasics.h"

#define slxFITS_NO_VALUE    "$noval$"

ccsCOMPL_STAT slxDecodeFormatDbl(const char    *format,
				 vltINT32      *precision,
				 vltLOGICAL    *expo,
				 vltLOGICAL    *capitalExpo,
				 ccsERROR      *error);

ccsCOMPL_STAT slxCreateFITS(const char          *category,
                            const char          *subSystem,
                            const char          *parameter,
                            const slxPAR_TYPE   parameterType,
                            const char          *stringValue,
                            const vltLOGICAL    logicalValue,
                            const vltINT32      integerValue,
                            const vltUINT8      precision,
                            const vltLOGICAL    exponential,
                            const vltDOUBLE     doubleValue,
                            const char          *comment,
                            char                *fitsLine,
                            ccsERROR            *error);

ccsCOMPL_STAT slxCreateFits2(const miscHASH_TABLE  dictionary,
			     const slxFITS_VALUE   value,
			     const vltLOGICAL      trimLine,
			     slxKEYW_LINE          fitsLine,
			     ccsERROR              *error, ...);

ccsCOMPL_STAT slxCreateFits2_v(const miscHASH_TABLE  dictionary,
			       const slxFITS_VALUE   value, 
			       const vltLOGICAL      trimLine,
			       slxKEYW_LINE          fitsLine,
			       ccsERROR              *error, 
			       va_list               argList);

ccsCOMPL_STAT slxCreateWriteFITS(const int          fd,
                                 const char         *category,
                                 const char         *subSystem,
                                 const char         *parameter,
                                 const slxPAR_TYPE  parameterType,
                                 const char         *stringValue,
                                 const vltLOGICAL   logicalValue,
                                 const vltINT32     integerValue,
                                 const vltUINT8     precision,
                                 const vltLOGICAL   exponential,
                                 const vltDOUBLE    doubleValue,
                                 const char         *comment,
                                 ccsERROR           *error);

ccsCOMPL_STAT slxCreateWriteFits2(const int             fd,
				  const miscHASH_TABLE  dictionary,
				  const slxFITS_VALUE   value,
				  ccsERROR              *error, ...);



ccsCOMPL_STAT slxCreateShortFITS(const char         *category,
                                 const char         *subSystem,
                                 const char         *parameter,
                                 const slxPAR_TYPE  parameterType,
				 const  char        *stringValue,
                                 const vltLOGICAL   logicalValue,
                                 const long int     integerValue,
                                 const vltUINT8     precision,
                                 const vltLOGICAL   exponential,
                                 const vltDOUBLE    doubleValue,
                                 const char         *comment,
                                 char               *fitsLine,
                                 ccsERROR           *error);

ccsCOMPL_STAT slxCreateShortFits2(const miscHASH_TABLE  dictionary,
				  const slxFITS_VALUE   value,
				  slxKEYW_LINE          fitsLine,
				  ccsERROR              *error, ...);

ccsCOMPL_STAT slxCreateShortFitsX(const miscHASH_TABLE  dictionary,
				  const slxFITS_VALUE   value,
				  slxKEYW_LINE          fitsLine,
				  ccsERROR              *error, ...);

ccsCOMPL_STAT slxCreStoreShFITSDicBuf(slxDYN_BUF           *setupBuf,
				      const slxCATEGORY    category,
				      const slxSUBSYSTEM   subSystem,
				      const slxPARAMETER   parameter,
				      const void           *value,
				      const slxDICTIONARY  dictionary,
				      ccsERROR             *error);

ccsCOMPL_STAT slxPrepImageFile(const slxFILENAME  fileName, 
                               const int          noOfBlocks,
                               const vltLOGICAL   writeEND,
                               ccsERROR           *error);

ccsCOMPL_STAT slxAddFITSBlocks(const int         fd, 
                               const vltUINT8    noOfBlocks,
                               const vltLOGICAL  writeEND,
                               ccsERROR          *error);

ccsCOMPL_STAT slxAddFITSBlocksWithEnd(const int         fd, 
                               const vltUINT8    noOfBlocks,
                               ccsERROR          *error);

ccsCOMPL_STAT slxDetectFormat(const slxFILENAME  fileName,
                              slxSETUP_FORMAT    *type,
                              ccsERROR           *error);

ccsCOMPL_STAT slxDetectFormatLine(const slxKEYW_LINE  keywordLine,
			          slxSETUP_FORMAT     *type,
                                  ccsERROR            *error);

ccsCOMPL_STAT slxNormalToShortFITS(const slxKEYW_LINE   normalFITS,
                                   slxKEYW_LINE         shortFITS,
                                   ccsERROR             *error);

ccsCOMPL_STAT slxShortToNormalFITS(const slxKEYW_LINE   shortFITS,
                                   slxKEYW_LINE         normalFITS,
                                   ccsERROR             *error);

ccsCOMPL_STAT slxShortToNormalFits2(const slxKEYW_LINE    shortFits,
				    slxKEYW_LINE          normalFits,
				    const miscHASH_TABLE  dictionary, 
                                    ccsERROR              *error);

ccsCOMPL_STAT slxSplitFITS(const slxKEYW_LINE   fitsLine, 
                           slxCATEGORY          category,
                           slxSUBSYSTEM         subSystem,
                           slxPARAMETER         parameter,
                           slxVALUE             value,
                           slxCOMMENT           comment,
                           ccsERROR             *error);

ccsCOMPL_STAT slxSplitFits2(const slxKEYW_LINE   fitsLine, 
			    slxCATEGORY          category,
			    slxSUBSYSTEM         subSystem1,
			    slxSUBSYSTEM         subSystem2,
			    slxPARAMETER         parameter,
			    slxVALUE             value,
			    slxCOMMENT           comment,
			    ccsERROR             *error);

ccsCOMPL_STAT slxSplitFitsDyn(const slxKEYW_LINE  shortFitsLine,
			      const vltINT32      maxNoOfKeyEls, 
			      slxKEYW_LINE        keyElements[],
			      vltINT32            *noOfKeyElements,
			      slxVALUE            value,
			      slxCOMMENT          comment,
			      ccsERROR            *error);

ccsCOMPL_STAT slxSplitShortFitsDyn(const slxKEYW_LINE  shortFitsLine,
				   const vltINT32      maxNoOfKeyEls, 
				   slxKEYW_LINE        keyElements[],
				   vltINT32            *noOfKeyElements,
				   slxVALUE            value,
				   slxCOMMENT          comment,
				   ccsERROR            *error);

ccsCOMPL_STAT slxAssShortFitsKey(const slxKEYW_LINE   keyElements[],
				 const vltINT32       noOfKeyElements,
				 slxKEYW_LINE         keyword,
				 ccsERROR             *error);

ccsCOMPL_STAT slxSplitShortFITS(const slxKEYW_LINE  shortFitsLine, 
				slxCATEGORY         category,
				slxSUBSYSTEM        subSystem,
				slxPARAMETER        parameter,
				slxVALUE            value,
				slxCOMMENT          comment,
				ccsERROR            *error);

ccsCOMPL_STAT slxSplitShortFits2(const slxKEYW_LINE  shortFitsLine, 
				 slxCATEGORY         category,
				 slxSUBSYSTEM        subSystem1,
				 slxSUBSYSTEM        subSystem2,
				 slxPARAMETER        parameter,
				 slxVALUE            value,
				 slxCOMMENT          comment,
				 ccsERROR            *error);

ccsCOMPL_STAT slxBuildImageFileName(const slxFILENAME  fileName,
				    slxFILENAME        completeName,
				    ccsERROR           *error);

ccsCOMPL_STAT slxLoadFitsHeaderBuf(slxFILENAME  fileName,
				   slxDYN_BUF   *headerBuf,
				   vltLOGICAL   *asciiFile,
				   ccsERROR     *error);

ccsCOMPL_STAT _slxConvert(const slxFITS_VALUE   value,
			  const slxDIC_HANDLE   *dicRec,
			  const vltINT32        precision,
			  char                  **commentPtr,
			  ccsERROR              *error);

#ifdef __cplusplus
}
#endif


#endif /*!slxFits_H*/
