/******************************************************************************
 * E.S.O. - VLT project
 *
 * "@(#) $Id: FitsTranslate.C,v 1.1.2.1 2008/09/11 08:14:32 cguirao Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  20/01/2000  Created
 */

/************************************************************************
 *   NAME
 *   FitsTranslate - FITS Translation Tool
 * 
 *   SYNOPSIS
 *   To get on-line help:
 * 
 *   % FitsTranslate -h
 * 
 *   DESCRIPTION
 *   The FitsTranslate tool implements a scheme for translating FITS
 *   files based on a FITS Translation Table (FTT).
 * 
 *   For further information, and to download the user manual, consult
 *   the FTU WEB page:
 *
 *                 http://archive.eso.org/ftu
 *
 *   FILES
 *
 *   ENVIRONMENT
 *
 *   COMMANDS
 *
 *   RETURN VALUES
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */
#define _POSIX_SOURCE 1

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ftuSESSION.h"

static const char *rcsId="@(#) $Id: FitsTranslate.C,v 1.1.2.1 2008/09/11 08:14:32 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


int main(int argc, char *argv[])
{
    ftuSESSION     ftuSession;
    utilFILE_MGR   filemgr;

    if (ftuSession.ParseInputPars(argc, argv) == FAILURE)
	exit(1);
    if (ftuSession.Execute() == FAILURE)
	goto errorReturn;

    exit(0);

  errorReturn:
    /*
    fprintf(stderr, "\nError occurred while executing translation!\n\n");
    if (ftuSession.ErrStack().errorsInStack)
	{
	fprintf(stderr, "Error Message:\n\n");
	errPrint(&ftuSession.ErrStack());
	fprintf(stderr, "\n\n");
	}
    */
    exit(1);
}

// --- oOo --- 
