#ifndef ftuCONDITIONS_H
#define ftuCONDITIONS_H
/******************************************************************************
 *
 * E.S.O. - Archive System
 *
 * "@(#) $Id: ftuCONDITIONS.h,v 1.2 2005/11/09 15:59:06 jknudstr Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  24/01/2000  Created
 */

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "utilLib.h"

#include "ftuBASE.h"

class ftuCONDITIONS: public ftuBASE
{
  public:
    ftuCONDITIONS();
    ~ftuCONDITIONS() {};

    void            Force(const utilLOGICAL force) {
	force_ = force;
    }	
    utilLOGICAL      Force() {
	return force_;
    }

    void            TestFiles(const utilLOGICAL testFiles) {
	testFiles_ = testFiles;
    }
    utilLOGICAL      TestFiles() {
	return testFiles_;
    }

    void            Checksum(const utilLOGICAL checksum) {
	checksum_ = checksum;
    }
    utilLOGICAL      Checksum() {
	return checksum_;
    }
    
    void            Statistics(const utilLOGICAL statistics) {
	statistics_ = statistics;
    }
    utilLOGICAL      Statistics() {
	return statistics_;
    }

    void            History(const utilLOGICAL history) {
	history_ = history;
    }
    utilLOGICAL      History() {
	return history_;
    }

    void            Comment(const utilLOGICAL comment) {
	comment_ = comment;
    }
    utilLOGICAL      Comment() {
	return comment_;
    }

    void            Version(const char   *version) {
	strcpy(version_, version);
    }
    char            *Version() {
	return version_;
    }   

    void            VersionDate(const char   *versionDate) {
	strcpy(versionDate_, versionDate);
    }
    char            *VersionDate() {
	return versionDate_;
    }   

    void            SkipFileOnError(const utilLOGICAL skipFileOnError) {
	skipFileOnError_ = skipFileOnError;
    }
    utilLOGICAL      SkipFileOnError() {
	return skipFileOnError_;
    }

    void            Tolerant(const utilLOGICAL tolerant) {
	tolerant_ = tolerant;
    }
    utilLOGICAL      Tolerant() {
	return tolerant_;
    }

    void            Overwrite(const utilLOGICAL overwrite) {
	overwrite_ = overwrite;
    }
    utilLOGICAL     Overwrite() {
	return overwrite_;
    }

    void            TargetDir(const slxFILENAME targetDir) {
	strcpy(targetDir_, targetDir);
    }
    char            *TargetDir() {
	return(targetDir_);
    }

    void            TargetFile(const slxFILENAME targetFile) {
	strcpy(targetFile_, targetFile);
    }
    char            *TargetFile() {
	return(targetFile_);
    }

    void            Repeat(const int times) {
	repeat_ = times;
    }
    int            Repeat() {
	return repeat_;
    }


  private:
    utilLOGICAL   force_;
    utilLOGICAL   testFiles_;
    utilLOGICAL   checksum_;
    utilLOGICAL   statistics_;
    utilLOGICAL   history_;
    utilLOGICAL   comment_;
    slxVALUE      version_;
    slxVALUE      versionDate_;
    utilLOGICAL   skipFileOnError_;
    utilLOGICAL   tolerant_;
    utilLOGICAL   overwrite_;
    slxFILENAME   targetDir_;
    slxFILENAME   targetFile_;
    int           repeat_;
};

#endif /*!ftuCONDITIONS_H*/

// --- oOo ---
