/******************************************************************************
 * E.S.O. - VLT project
 *
 * "@(#) $Id: ftuCheckSum.C,v 1.1.2.1 2008/09/11 08:11:40 cguirao Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  02/02/2000  Created
 */

/************************************************************************
 *   NAME
 *   
 * 
 *   SYNOPSIS
 *   
 * 
 *   DESCRIPTION
 *
 *   FILES
 *
 *   ENVIRONMENT
 *
 *   COMMANDS
 *
 *   RETURN VALUES
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */

static const char *rcsId="@(#) $Id: ftuCheckSum.C,v 1.1.2.1 2008/09/11 08:11:40 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#define _POSIX_SOURCE 1

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ftuBASE.h"

#define CHUNK (1 * 2880)



int main(int argc, char *argv[])
{

    if (argc != 2)
	{
	fprintf(stderr, "\n\nCorrect usage:\n\n%% %s "
		"<FITS file>\n\n", argv[0]);
	exit(1);
	}

    FILE *filePtr;
    if ((filePtr = fopen(argv[1], "r")) == NULL)
	{
	fprintf(stderr, "\n\nCouldn't open file: %s.\n\n", argv[1]);
	exit(1);
	}

    // Loop over the file and calculate the checksum on the chunks.
    char                buf[CHUNK];
    int                 len; 
    unsigned long       sum = 0;
    do
	{
	len = fread(buf, 1, CHUNK, filePtr);
	if (len > 0)
	    ffcsum(buf, (len / 2880), &sum);
	}
    while (len > 0);
    fclose(filePtr);

    char   checkSum[32];

    ffesum(sum, 1, checkSum);
    printf("\nChecksum calculated to (complement): %ld (%s)", ~sum, 
	   checkSum);

    ffesum(sum, 0, checkSum);
    printf("\nChecksum calculated to             : %ld (%s)\n\n", sum, 
	   checkSum);

    exit(0);
}

// --- oOo --- 







