#ifndef ftuTRANSLATION_H
#define ftuTRANSLATION_H
/******************************************************************************
 *
 * E.S.O. - Archive System
 *
 * "@(#) $Id: ftuTRANSLATION.h,v 1.1 2004/09/06 14:38:35 cguirao Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  20/01/2000  Created
 */

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "ftuBASE.h"
#include "ftuVALUE_SRC.h"

// Callback to handle deletion of the ftuTRANSLATION class.
void fttTranslationDeleteEl(void *elPtr);
class ftuTRANSLATION_HASH: public utilHASH
{
  public:
    ftuTRANSLATION_HASH() {
	SetDeleteElFct(fttTranslationDeleteEl);
    }
};


class ftuTRANSLATION: public ftuBASE
{
  public:
    ftuTRANSLATION(const ftuACTION action = ftuUNKNOWN);
    ~ftuTRANSLATION();

    utilSTAT   Clear();

    utilSTAT   SetAction(const ftuACTION  action);
    ftuACTION  GetAction();

    utilSTAT   SetSrcKey(const slxKEYW_LINE  key);
    char       *GetSrcKey();

    utilSTAT   SetTargKey(const slxKEYW_LINE  key);
    char       *GetTargKey();

    utilSTAT   SetSrcHdr(const slxKEYW_LINE  hdr);
    int        GetSrcHdr();

    utilSTAT   SetTargHdr(const slxKEYW_LINE  hdr);
    int        GetTargHdr();

    utilSTAT   AddValueSrcAdr(const char    *valueSrc,
			      const char    *srcAdr,
			      const int     header = ftuUNDEFINED);

    utilSTAT   SetFct(const slxKEYW_LINE  fct);
    char       *GetFct();

    int        NoOfValues();
    utilSTAT   GetValue(const int      valueNo,
			ftuVALUE_SRC   **value);

    //int        HasValSrc(const char    *valueSrc);

  protected:
  private:
    ftuACTION          action_;
    
    slxKEYW_LINE       srcKey_;
    slxKEYW_LINE       targKey_;

    int                srcHdr_;
    int                targHdr_;

    slxKEYW_LINE       fct_;

    // Yes, it's a bit extravagant to use a hash table for this, as even 
    // an empty hash table takes up some memory (2500 * 4 bytes).
    ftuVALUE_SRC_HASH  valueTbl_;
};

#endif /*!ftuTRANSLATION_H*/

// --- oOo ---
