#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: FtuFttDefs.py,v 1.1 2004/09/06 14:38:37 cguirao Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  06/02/2001  Created
#


"""
Contains definitions of various properties for the FTU FTT Python API.

Defined variables to refer to the various actions:

    o ftuACTION_UNDEF
    
    o ftuACTION_HDR_DUMP
    
    o ftuACTION_FILE_PATH
    
    o ftuACTION_FILE_RENAME
    
    o ftuACTION_FILE_SPLIT
    
    o ftuACTION_ADD
    
    o ftuACTION_CHANGE

    o ftuACTION_RENAME
    
    o ftuACTION_MOVE

    o ftuACTION_COPY
    
    o ftuACTION_REMOVE


For referring to Value Sources:

    o ftuVAL_SRC_UNDEF
    
    o ftuVAL_SRC_KEY
    
    o ftuVAL_SRC_CONST
    
    o ftuVAL_SRC_FCT


For referring to Dictionary Types:

    o ftuTYPE_UNDEF

    o ftuTYPE_STRING

    o ftuTYPE_LOGICAL

    o ftuTYPE_INTEGER

    o ftuTYPE_DOUBLE


It is recommended to use these variables, rather hard coding the values
into the P-FTTs.
"""
ftuACTION_UNDEF         = ""

ftuACTION_HDR_DUMP      = "HDR.DUMP"

ftuACTION_FILE_PATH     = "FILE.PATH"
ftuACTION_FILE_RENAME   = "FILE.RENAME"
ftuACTION_FILE_SPLIT    = "FILE.SPLIT"

ftuACTION_ADD           = "ADD"
ftuACTION_CHANGE        = "CHANGE"
ftuACTION_RENAME        = "RENAME"
ftuACTION_MOVE          = "MOVE"
ftuACTION_COPY          = "COPY"
ftuACTION_REMOVE        = "REMOVE"
                 

"""
Defined variables to refer to the various actions:

    o ftuVAL_SRC_KEY
    o ftuVAL_SRC_CONST
    o ftuVAL_SRC_FCT   
    
These are defined in the module "FtuFttDefs".
"""
ftuVAL_SRC_UNDEF = ""
ftuVAL_SRC_KEY   = "KEY"
ftuVAL_SRC_CONST = "CONST"
ftuVAL_SRC_FCT   = "FCT"


"""
Defined variables to refer to Dictionary types:

    o ftuTYPE_STRING
    o ftuTYPE_LOGICAL
    o ftuTYPE_INTEGER
    o ftuTYPE_DOUBLE

These are defined in the module "FtuFttDefs".
"""
ftuTYPE_UNDEF   = ""
ftuTYPE_STRING  = "string"
ftuTYPE_LOGICAL = "logical"
ftuTYPE_INTEGER = "integer"
ftuTYPE_DOUBLE  = "double"


# ___oOo___
