#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: FtuFttFilePath.py,v 1.1 2004/09/06 14:38:37 cguirao Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  16/02/2001  Created
#

"""
Class to handle a File Path Definition.
"""


from   FtuFttActionBase import *
import FtuFttFileAction


class FtuFttFilePath(FtuFttFileAction.FtuFttFileAction):
    """
    Class to handle the information in connection with a File Path Action.
    """


    def __init__(self,
                 base = "",
                 valueSrcList = None):
        """
        Constructor method initializing the object class variables.

        base            Set the base for the filename.
        
        valueSrcList    List of FtuFttValueSrc objects.
        """
        FtuFttFileAction.FtuFttFileAction.__init__(self)
        self.setAction(ftuACTION_FILE_PATH)
        self.setPrefix(base)
        self.setValueSrcList(valueSrcList)


    def setFilePathFromFtt(self,
                           keyCount,
                           fttPafObj):
        """
        Set the information in the object from the information in a PCC PAF
        object and return an updated keyword counter (index into the PccPaf
        object).
        
        keyCount     Keyword index into the PccPaf object.
         
        fttPafObj    Reference to PccPaf object containing the FTT.

        Returns:     Updated keyword counter.
        """
        return self._setFileActionFromFtt(ftuACTION_FILE_PATH,
                                          keyCount, fttPafObj)


    def setFilePath(self,
                    base,
                    valueSrcList = None):
        """
        Set up the object.

        base            Base name for the path construction.
        
        valueSrcList    Reference to list containing FtuFttValueSrc objects.

        Returns:        Reference to object itself.
        """
        self._setFileAction(base, valueSrcList)
        return self
    
#
# ___oOo___
