#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: FtuFttFileRename.py,v 1.1 2004/09/06 14:38:37 cguirao Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  16/02/2001  Created
#

"""
Class to handle the properties of a File Rename Action.
"""

from   FtuFttActionBase import *
import FtuFttFileAction


class FtuFttFileRename(FtuFttFileAction.FtuFttFileAction):
    """
    Class to handle the information in connection with a File Rename Action.
    """


    def __init__(self,
                 base = "",
                 valueSrcList = None):
        """
        Constructor method initializing the object class variables.

        base          Base name for the filename.
        
        valueSrcList  List containing FtuFttValueSrc objects.
        """
        FtuFttFileAction.FtuFttFileAction.__init__(self)
        self.setAction(ftuACTION_FILE_RENAME)
        self.setPrefix(base)
        self.setValueSrcList(valueSrcList)


    def setFileRenameFromFtt(self,
                             keyCount,
                             fttPafObj):
        """
        Set the information in the object from an FTT contained in a
        PccPaf object.

        keyCount    Keyword counter (index) into the FTT PAF object.

        fttPafObj   Reference to the PAF object containing the FTT.

        Returns:    Updated key counter.
        """
        return self._setFileActionFromFtt(ftuACTION_FILE_RENAME,
                                          keyCount, fttPafObj)

    
    def setFileRename(self,
                      prefix,
                      valueSrcList = None):
        """
        Set up the File Rename Action.
        
        prefix         Base for the new filename.
        
        valueSrcList   List containing FtuFttValueSrc objects.

        Returns:       Reference to object itself.
        """
        self._setFileAction(prefix, valueSrcList)
        return self

#
# ___oOo___
