#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: FtuFttFileSplit.py,v 1.1 2004/09/06 14:38:37 cguirao Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  16/02/2001  Created
#

"""
Class to handle the properties of a File Split Action.
"""

from   FtuFttActionBase import *
import FtuFttFileAction


class FtuFttFileSplit(FtuFttFileAction.FtuFttFileAction):
    """
    Class to handle the information in connection with a File Split Action.
    """


    def __init__(self,
                 base = "",
                 valueSrcList = None):
        """
        Constructor method initializing the object class variables.

        base            Base name for the target files.
        
        valueSrcList    List containing FtuFttValueSrc objects.
        """
        FtuFttFileAction.FtuFttFileAction.__init__(self)
        self.setAction(ftuACTION_FILE_SPLIT)
        self.setPrefix(base)
        self.setValueSrcList(valueSrcList)


    def setFileSplitFromFtt(self,
                            keyCount,
                            fttPafObj):
        """
        Set the information of the object from the keywords starting at
        the key index given by "keyCount" and return an updated key
        counter.
        
        keyCount      Keyword counter - index into the PAF object.
        
        fttPafObj     Reference to PccPaf object containing the FTT.

        Returns:      Updated key counter.
        """
        return self._setFileActionFromFtt(ftuACTION_FILE_SPLIT,
                                          keyCount, fttPafObj)


    
    def setFileSplit(self,
                     prefix,
                     valueSrcList = None):
        """
        Set up the File Split Action

        prefix        Basename for the target filenames.
        
        valueSrcList  List containing FtuFttValueSrc objects.

        Returns:      Reference to object itself.
        """
        self._setFileAction(prefix, valueSrcList)
        return self
    
#
# ___oOo___
