#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: FtuFttTest.py,v 1.1 2004/09/06 14:38:37 cguirao Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  20/02/2001  Created
#

import os, sys
import PccTestUt, PccKey
from   PccLog import *
from   FtuFttDefs import *
import FtuFtt, FtuFttValueSrc, FtuFttAction, FtuFttDicRec


# Declare common variables.
test = PccTestUt.PccTestUt()
test.parseInputPars(sys.argv)
python = "/opsw/util/python/bin/python"

info(1, "Executing Tests ...")


###########################################################################
# 1_1: Test reading/writing of FTT with all possible keywords
###########################################################################
base_1_1  = test.getPwd() + "/" + "Test_1_1_Base.ftt"
input_1_1 = base_1_1
targ_1_1  = test.getPwd() + "/" + "Test_1_1_Targ.ftt"
ref_1_1   = test.getPwd() + "/" + "Test_1_1_Ref.ftt"
cmd = python + " ../ftuPyLib/FtuFtt.py " + input_1_1 + " > " + targ_1_1
test.stdTest("Test-1_1-Basic-Test-Read-Write-FTT", 1,
             cmd, base_1_1, input_1_1, targ_1_1, ref_1_1)
###########################################################################

###########################################################################
# 1_2: Build up FTT with all possible actions.
###########################################################################
if ((test.getDisableTests() != 1) or 0):
    base_1_2  = ""
    input_1_2 = ""
    targ_1_2  = test.getPwd() + "/" + "Test_1_2_Targ.ftt"
    ref_1_2   = test.getPwd() + "/" + "Test_1_2_Ref.ftt"
    testName  = "Test-1_2-Building-FTT-In-Program"

    ftt_1_2 = FtuFtt.FtuFtt()

    # Add Include Statement.
    ftt_1_2.addIncludeRef(PccKey.PccKey("INCLUDE", "FTT.ftt"))

    # Add Dictionary References.
    ftt_1_2.addDicRef(PccKey.PccKey("DICTIONARY", "DictionaryOne"))
    ftt_1_2.addDicRef("DictionaryTwo")

    # Set File Path Definition.
    filePath = ftt_1_2.getFilePathAction()
    filePath.setFilePath("$FILENAME_")
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_KEY,
                                        "FILE.PATH.CONCAT.KEY_1",1))
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_CONST,
                                        "FILE.PATH.CONCAT.CONST_1"))
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_FCT,
                                        "FILE.PATH.CONCAT.FCT_1"))
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_KEY,
                                        "FILE.PATH.CONCAT.KEY_2",2))
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_CONST,
                                        "FILE.PATH.CONCAT.CONST_2"))
    filePath.addValueSrc(FtuFttValueSrc.\
                         FtuFttValueSrc(ftuACTION_FILE_PATH,
                                        ftuVAL_SRC_FCT,
                                        "FILE.PATH.CONCAT.FCT_2"))

    # Set Header Dump Definition.
    ftt_1_2.setHdrDump("NO_NEWLINE")
    
    # Set File Rename Definition.
    fileRename = ftt_1_2.getFileRenameAction()
    fileRename.setFileRename("FILE.RENAME.PREFIX_1")
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_KEY,
                                          "FILE.RENAME.CONCAT.KEY_1",1))
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_CONST,
                                          "FILE.RENAME.CONCAT.CONST_1"))
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_FCT,
                                          "FILE.RENAME.CONCAT.FCT_1"))
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_KEY,
                                          "FILE.RENAME.CONCAT.KEY_2",2))
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_CONST,
                                          "FILE.RENAME.CONCAT.CONST_2"))
    fileRename.addValueSrc(FtuFttValueSrc.\
                           FtuFttValueSrc(ftuACTION_FILE_RENAME,
                                          ftuVAL_SRC_FCT,
                                          "FILE.RENAME.CONCAT.FCT_2"))

    # Set File Split Definition.
    fileSplit = ftt_1_2.getFileSplitAction()
    fileSplit.setFileSplit("FILE.SPLIT.PREFIX_1")
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_KEY,
                                         "FILE.SPLIT.CONCAT.KEY_1",1))
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_CONST,
                                         "FILE.SPLIT.CONCAT.CONST_1"))
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_FCT,
                                         "FILE.SPLIT.CONCAT.FCT_1"))
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_KEY,
                                         "FILE.SPLIT.CONCAT.KEY_2",2))
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_CONST,
                                         "FILE.SPLIT.CONCAT.CONST_2"))
    fileSplit.addValueSrc(FtuFttValueSrc.\
                          FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                         ftuVAL_SRC_FCT,
                                         "FILE.SPLIT.CONCAT.FCT_2"))
    
    # Add an Add Action.
    addAction = FtuFttAction.FtuFttAction(ftuACTION_ADD, "ADD.KEY_1", 11)
    valSrc1 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_KEY,
                                            "ADD.VALUE.KEY_1_1")
    valSrc2 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_CONST,
                                            "ADD.VALUE.CONST_1_1")
    valSrc3 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_FCT,
                                            "ADD.VALUE.FCT_1_1")
    valSrc4 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_KEY,
                                            "ADD.VALUE.KEY_1_2")
    valSrc5 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_CONST,
                                            "ADD.VALUE.CONST_1_2")
    valSrc6 = FtuFttValueSrc.FtuFttValueSrc(ftuACTION_ADD, ftuVAL_SRC_FCT,
                                            "ADD.VALUE.FCT_1_2")
    addAction.setValueSrcList([valSrc1, valSrc2, valSrc3, valSrc4,
                               valSrc5, valSrc6])
    addAction.setFct("ADD.FCT_1")
    ftt_1_2.addAction(addAction)
    
    # Add a Change Action.
    changeAction = FtuFttAction.\
                   FtuFttAction(ftuACTION_CHANGE, "CHANGE.KEY_1", 11)
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_KEY,
                                            "CHANGE.VALUE.KEY_1_1"))
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_CONST,
                                            "CHANGE.VALUE.CONST_1_1"))
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_FCT,
                                            "CHANGE.VALUE.FCT_1_1"))
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_KEY,
                                            "CHANGE.VALUE.KEY_1_2"))
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_CONST,
                                            "CHANGE.VALUE.CONST_1_2"))
    changeAction.addValueSrc(FtuFttValueSrc.\
                             FtuFttValueSrc(ftuACTION_CHANGE,
                                            ftuVAL_SRC_FCT,
                                            "CHANGE.VALUE.FCT_1_2"))
    changeAction.setFct("CHANGE.FCT_1")
    ftt_1_2.addAction(changeAction)

    # Add a Rename Action.
    renameAction = FtuFttAction.FtuFttAction()
    renameAction.setRenameAction("RENAME.SRCKEY_1", "RENAME.TRGKEY_1", 11,
                                 "RENAME.FCT_1")
    ftt_1_2.addAction(renameAction)
    
    # Add Move Action.
    moveAction = FtuFttAction.FtuFttAction()
    moveAction.setMoveAction("MOVE.KEY_1", 11, 12, "MOVE.FCT_1")
    ftt_1_2.addAction(moveAction)
    
    # Add Copy Action.
    copyAction = FtuFttAction.FtuFttAction()
    copyAction.setCopyAction("COPY.SRCKEY_1", 11, "COPY.TRGKEY_1", 12,
                             "COPY.FCT_1")
    ftt_1_2.addAction(copyAction)
    
    # Add Remove Action.
    removeAction = FtuFttAction.FtuFttAction()
    removeAction.setRemoveAction("REMOVE.KEYLIST_1", 11)
    ftt_1_2.addAction(removeAction)
    
    # Add Dictionary Records.
    ftt_1_2.addDicRec(FtuFttDicRec.FtuFttDicRec("DIC.KEY_1", "string", "%s",
                                                "Comment 1"))
    ftt_1_2.addDicRec(FtuFttDicRec.FtuFttDicRec("DIC.KEY_2", "logical", "%c",
                                                "Comment 2"))
    ftt_1_2.addDicRec(FtuFttDicRec.FtuFttDicRec("DIC.KEY_3", "integer", "%d",
                                                "Comment 3"))
    ftt_1_2.addDicRec(FtuFttDicRec.FtuFttDicRec("DIC.KEY_4", "double", "%f",
                                                "Comment 4"))

    # Save the FTT to disk.
    ftt_1_2.save(targ_1_2)

    # Check if result as expected.
    test.compareFiles(targ_1_2, ref_1_2, testName)
###########################################################################

###########################################################################
# 1_3: Build up small FTT and execute this on a FITS file (VIMOS).
###########################################################################
if ((test.getDisableTests() != 1) or 0):
    base_1_3    = test.getPwd() + "/" + "Vimos_Small_Test_1_3_Base.fits.gz"
    input_1_3   = test.getPwd() + "/" + "Vimos_Small_Test_1_3_Input.fits"
    targ_1_3_1  = test.getPwd() + "/" + "Vimos_Small_Test_1_3_Input.2.fits"
    targ_1_3_2  = test.getPwd() + "/" + "Vimos_Small_Test_1_3_Input.3.fits"
    ref_1_3_1   = test.getPwd() + "/" + "Test_1_3_1_Ref.fits"
    ref_1_3_2   = test.getPwd() + "/" + "Test_1_3_2_Ref.fits"
    testName    = "Test-1_3-Build-Execute-FTT"

    ftt_1_3 = FtuFtt.FtuFtt()

    # Add Remove Actions.
    for hdrNo in [1, 2]:
        ftt_1_3.addAction(FtuFttAction.FtuFttAction().\
                          setRemoveAction("XTENSION,EXTNAME,ORIGIN,"+
                                          "DET.CHIP.XGAP,DET.CHIP.YGAP",hdrNo))
    for hdrNo in [1, 2]:
        ftt_1_3.addAction(FtuFttAction.FtuFttAction().\
                          setRemoveAction("INS.SLIT*.*", hdrNo))

    # Add Change Actions.
    for valSet in [["DET.CHIPS", 1,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_CONST, "1"]], ""],
                   
                   ["DET.OUTPUTS", 1,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_CONST, "1"]], ""],
                   
                   ["DET.WIN1.NX", 1,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_KEY, "DET.WIN1.NX"],
                     [ftuACTION_CHANGE, ftuVAL_SRC_CONST, "0.5"]],
                    "MultiplyDouble"],
                   
                   ["DET.CHIPS", 2,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_CONST, "1"]], ""],
                   
                   ["DET.OUTPUTS", 2,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_CONST, "1"]], ""],
                   
                   ["DET.OUT.X", 2,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_CONST, "1"]], ""],
                   
                   ["DET.WIN1.NX", 2,
                    [[ftuACTION_CHANGE, ftuVAL_SRC_KEY, "DET.WIN1.NX"],
                     [ftuACTION_CHANGE, ftuVAL_SRC_CONST, "0.5"]],
                    "MultiplyDouble"]]:
        valSrcList = []
        for valSrc in valSet[2]:
            valSrcList.append(FtuFttValueSrc.\
                              FtuFttValueSrc(valSrc[0], valSrc[1], valSrc[2])) 
        ftt_1_3.addAction(FtuFttAction.FtuFttAction().\
                          setChangeAction(valSet[0], valSet[1], valSrcList,
                                          valSet[3]))
        
    # Set File Split Action.
    valSrcs = [FtuFttValueSrc.FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                             ftuVAL_SRC_CONST, "."),
               FtuFttValueSrc.FtuFttValueSrc(ftuACTION_FILE_SPLIT,
                                             ftuVAL_SRC_KEY, "OCS.CON.QUAD")]
    ftt_1_3.getFileSplitAction().setFileSplit("$FILENAME", valSrcs)
    
    # Prepare FITS file for test + execute the FTT.
    test.removeFiles([targ_1_3_1, targ_1_3_2])
    test.prepareFiles(base_1_3, input_1_3, "")
    fttName = test.getPwd() + "/" + "TestFtt_1_3.ftt"
    logFile = ""
    logLevel = 0
    tolerant = 0
    force = 0
    testPar = 0
    noStat = 0
    noChecksum = 0
    noHistory = 1
    ftt_1_3.execute(input_1_3, fttName, logFile, logLevel, tolerant, force,
                    testPar, noStat, noChecksum, noHistory)

    # Compare output files.
    test.compareFiles(ref_1_3_1, targ_1_3_1, testName + "/1")
    test.compareFiles(ref_1_3_2, targ_1_3_2, testName + "/2")

    # Clean up.
    test.removeFiles([targ_1_3_1, targ_1_3_2, fttName])
###########################################################################

#
# ___oOo___
