/******************************************************************************
 * E.S.O. - Archive System
 *
 * "@(#) $Id: utilCHRONOMETER.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  28/01/2000  Created 
 */

/************************************************************************
 *
 *   NAME
 *   
 * 
 *   SYNOPSIS
 *   
 *   PARENT CLASS
 * 
 *   DESCRIPTION
 *
 *   PUBLIC METHODS
 *
 *   PUBLIC DATA MEMBERS
 *
 *   PROTECTED METHODS
 *
 *   PROTECTED DATA MEMBERS
 *
 *   FILES
 *
 *   ENVIRONMENT
 *
 *   RETURN VALUES
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */

static const char *rcsId="@(#) $Id: utilCHRONOMETER.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#define _ALL_SOURCE 1
#define __EXTENSIONS__ 1

#include <stdlib.h>
#include <string.h>

#include "utilCHRONOMETER.h"

#if defined(__linux__)
    #include <sys/time.h>
    #include <unistd.h>
#endif

utilCHRONOMETER::utilCHRONOMETER()
{
}

utilCHRONOMETER::~utilCHRONOMETER()
{
}


utilSTAT utilCHRONOMETER::Start(const char *timerName)
{
    struct timeval   timeNow, *timePtr;
    
    gettimeofday(&timeNow, NULL);
    timePtr = (struct timeval *)malloc(sizeof(struct timeval));
    memcpy(timePtr, &timeNow, sizeof(struct timeval));
    if (timerTbl_.AddEl(timerName, (void **)&timePtr) == FAILURE)
	return FAILURE;

    return SUCCESS;    
}

utilSTAT utilCHRONOMETER::Stop(const char  *timerName,
			     double      *time)
{
    struct timeval   timeNow, *timePtr;
    double           timeSec, timeUSec;

    gettimeofday(&timeNow, NULL); 
    if (timerTbl_.GetEl(timerName, (void **)&timePtr) == FAILURE)
	return FAILURE;
 
    timeSec = (timeNow.tv_sec - timePtr->tv_sec);
    if (timeNow.tv_usec >= timePtr->tv_usec)
	timeUSec = (timeNow.tv_usec - timePtr->tv_usec);
    else
	{
	timeUSec = (1000000 + timeNow.tv_usec - timePtr->tv_usec);
	timeSec--;
	}
    *time = (timeSec + (timeUSec / 1e6));

    return SUCCESS;
}

double   utilCHRONOMETER::Stop(const char  *timerName)
{
    double  timeDif;
    if (Stop(timerName, &timeDif) == FAILURE)
	{
	errCloseStack(&ErrStack());
	return -1;
	}    

    return timeDif;
}


/*___oOo___*/
