/******************************************************************************
 * E.S.O. - Archive System
 *
 * "@(#) $Id: utilERROR.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"
 *
 * Who       When        What
 * --------  ----------  ----------------------------------------------
 * jknudstr  15/01/2000  Created 
 */

/************************************************************************
 *
 *   NAME
 *   
 * 
 *   SYNOPSIS
 *   
 *   PARENT CLASS
 * 
 *   DESCRIPTION
 *
 *   PUBLIC METHODS
 *
 *   PUBLIC DATA MEMBERS
 *
 *   PROTECTED METHODS
 *
 *   PROTECTED DATA MEMBERS
 *
 *   FILES
 *
 *   ENVIRONMENT
 *
 *   RETURN VALUES
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */

static const char *rcsId="@(#) $Id: utilERROR.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include <stdio.h>
#include <string.h>

#include "slx.h"

#include "utilERROR.h"


utilERROR::utilERROR()
{
    severity_ = utilERR_NO_ERROR;
}

utilERROR::~utilERROR()
{
}

utilSTAT utilERROR::ClearStack()
{
    if (ErrStackReset() == FAILURE)
	return FAILURE;
    severity_ = utilERR_NO_ERROR;
    return SUCCESS;
}
    
utilSTAT utilERROR::CloseStack()
{

    if (ErrStackClose() == FAILURE)
	return FAILURE;
    severity_ = utilERR_NO_ERROR;
    return SUCCESS;
}

void    utilERROR::Severity(const utilERR_SEVERITY  severity)
{
    if (severity > severity_)
	severity_ = severity;
}

utilERR_SEVERITY utilERROR::Severity()
{
    return severity_;
}

utilSTAT utilERROR::ErrAdd(ccsMODULEID             moduleId, 
			   char                    *errorMnemonic,
			   const utilERR_SEVERITY  severity, ...)
{ 
    va_list       argPtr;
    utilSTAT      stat;

    ErrStatus(FAILURE);
    va_start(argPtr, severity);  
    stat = errAdd_v(&ErrStack(), moduleId, errorMnemonic, __FILE_LINE__, 
		    NULL, argPtr);
    va_end(argPtr);
    SetTimeStamp_();

    if (severity > Severity())
	Severity(severity);

    return stat;
}

utilSTAT utilERROR::ErrSysAdd(ccsMODULEID             moduleId, 
			      char                    *errorMnemonic, 
			      const utilERR_SEVERITY  severity, ...)
{ 
    va_list       argPtr;
    utilSTAT       stat;

    ErrStatus(FAILURE);
    va_start(argPtr, severity);
    stat = errSysAdd_v(&ErrStack(), moduleId, errorMnemonic, __FILE_LINE__, 
                       NULL, modUNIX, argPtr);
    va_end(argPtr);
    SetTimeStamp_();

    if (severity > Severity())
	Severity(severity);

    return stat;
}

utilSTAT utilERROR::SetTimeStamp_()
{   
    slxKEYW_LINE    dayTime;

    if (slxGenDayTimPrec(4, dayTime, &ErrStack()) == FAILURE)
	return FAILURE;
    if (NoOfErrors() <= 0)
	return SUCCESS;

    ccsSTACK_ELEM   *errEl;
    errEl = GetError(NoOfErrors() - 1);
    strcpy((char *)errEl->timeStamp, dayTime);
	
    return SUCCESS;
}

int     utilERROR::NoOfErrors()
{
    return stdErr->errorsInStack;
}

ccsSTACK_ELEM *utilERROR::GetError(const int errorNo)
{
    return &(stdErr->errorStack[errorNo]);
}

/*___oOo___*/
