/******************************************************************************
 * E.S.O. - VLT project
 *
 * "@(#) $Id: utilHASH.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"
 *
 * who       when      what
 * --------  --------  ----------------------------------------------
 * jknudstr  14/02/99  created 
 */

/************************************************************************
 *   NAME
 *   
 * 
 *   SYNOPSIS
 *
 *   
 *   PARENT CLASS
 *
 * 
 *   DESCRIPTION
 *
 *
 *   PUBLIC METHODS
 *
 *
 *   PUBLIC DATA MEMBERS
 *
 *
 *   PROTECTED METHODS
 *
 *
 *   PROTECTED DATA MEMBERS
 *
 *
 *   PRIVATE METHODS
 *
 *
 *   PRIVATE DATA MEMBERS
 *
 *
 *   FILES
 *
 *   ENVIRONMENT
 *
 *   COMMANDS
 *
 *   RETURN VALUES
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */

#define _POSIX_SOURCE 1

static const char *rcsId="@(#) $Id: utilHASH.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include <stdlib.h>
#include <stdio.h>

#include "utilHASH.h"

void  utilDeleteEl(void *elPtr)
{
    free(elPtr);
}


utilHASH::utilHASH(utilHASH_DEL_CB fct)
{
    SetDeleteElFct(utilDeleteEl);
    //deleteElCb_ = utilDeleteEl;
    miscHashInit(hashTable_);
    errResetStack(&intCcsError_);
    noOfEls_ = 0;
}

utilHASH::~utilHASH()
{
    DeleteTable();
}

void  utilHASH::DeleteEl(void *elPtr)
{
    free(elPtr);
}

void utilHASH::SetDeleteElFct(utilHASH_DEL_CB  fct)
{
    deleteElCb_ = fct;  
}

utilSTAT  utilHASH::DeleteTable()
{
    miscHASH_EL   *hashElPtr;
    miscHASH_EL   *hashDelPtr;
    vltINT32      i;

    for (i = 0; i < miscNO_OF_HASH_ELS; i++)
	{
	if (hashTable_[i] != NULL)
	    {
	    hashElPtr = hashTable_[i];
	    while (hashElPtr != NULL)
		{
		hashDelPtr = hashElPtr;
		hashElPtr = hashElPtr->next;
		free(hashDelPtr->key);
		hashDelPtr->key = (char *)NULL;
		if (hashDelPtr->element != NULL)
		    deleteElCb_(hashDelPtr->element);
		//DeleteEl(hashDelPtr->element);
		hashDelPtr->element = (void *)NULL;
		free(hashDelPtr);		
		hashDelPtr = (miscHASH_EL *)NULL;
		hashTable_[i] = (miscHASH_EL *)NULL;
		}
	    }
	}

    noOfEls_ = 0;

    return SUCCESS;
}

int utilHASH::NoOfEls()
{
    return noOfEls_; 
}

utilSTAT  utilHASH::AddEl(const char      *key,
			  void            **element)
{
    if (miscHashAddElement(hashTable_, key, element, &ErrStack()) == FAILURE)
	return FAILURE;
    noOfEls_++;
    return SUCCESS;
}

utilSTAT  utilHASH::AddEl(const int       key,
			  void            **element)
{
    char  hashKey[64];
    
    sprintf(hashKey, "%d", key);
    if (miscHashAddElement(hashTable_, hashKey, element, 
			   &ErrStack()) == FAILURE)
	return FAILURE;
    noOfEls_++;
    return SUCCESS;
}

utilSTAT  utilHASH::AddIntEl(const char      *key,
			     const vltINT32  intVal)
{
    vltINT32  *intP;

    intP = (vltINT32 *)malloc(sizeof(vltINT32));
    *intP = intVal;
    if (miscHashAddElement(hashTable_, key, (void **)&intVal, 
			   &ErrStack()) == FAILURE)
	return FAILURE;
    noOfEls_++;
    return SUCCESS;
}

utilSTAT  utilHASH::GetIntEl(const char      *key,
			     vltINT32        *intVal)
{
    vltINT32  *intP;

    if (GetEl(key, (void **)&intP) == FAILURE)
	return FAILURE;
    *intVal = *intP;

    return SUCCESS;
}


utilSTAT  utilHASH::FreeEl(const char      *key)
{
    if (miscHashDeleteEl(hashTable_, key, &ErrStack()) == FAILURE)
	return FAILURE; 
    noOfEls_--;
    return SUCCESS;
}


utilSTAT  utilHASH::GetEl(const char      *key,
			  void            **element)
{
    if (miscHashGetEl(hashTable_, key, element, &ErrStack()) == FAILURE)
	return FAILURE;
    return SUCCESS;
}

utilSTAT  utilHASH::GetEl(const int       key,
			  void            **element)
{
    char  hashKey[64];
    
    sprintf(hashKey, "%d", key);
    if (miscHashGetEl(hashTable_, hashKey, element, &ErrStack()) == FAILURE)
	return FAILURE;
    return SUCCESS;
}

utilSTAT  utilHASH::GetSeq(const vltLOGICAL  initialize,
			   void              **element)
{
    if (miscHashGetSeq(hashTable_, initialize, element,
		       &ErrStack()) == FAILURE)
	return FAILURE;

    return SUCCESS;
}

vltLOGICAL  utilHASH::ElInTable(const char      *key)
{
    void *element;
    
    if (miscHashGetEl(hashTable_, key, &element, &intCcsError_) == FAILURE)
	{
	errResetStack(&intCcsError_);
	return FALSE;
	}
    else
	return TRUE;
}


/*___oOo___*/
