/******************************************************************************
 * E.S.O. - Archive System
 *
 * "@(#) $Id: utilUtils.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"
 *
 * Who       When      What
 * --------  --------  ----------------------------------------------
 * jknudstr  01/09/99  Created 
 */

/************************************************************************
 *
 *   NAME
 *   
 * 
 *   SYNOPSIS
 *
 *   CAUTIONS 
 *
 *   EXAMPLES
 *
 *   SEE ALSO
 *
 *   BUGS   
 * 
 *------------------------------------------------------------------------
 */

static const char *rcsId="@(#) $Id: utilUtils.C,v 1.2 2008/09/04 15:47:41 cguirao Exp $"; 
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <regex.h>
#include <string.h>

#include "slx.h"
#include "utilDefs.h"
#include "utilTYPES.h"

int utilRegExp(const char *regExp,
	      const char *string)
{
    int       match = FALSE;
    regex_t   preg;

    if (regcomp(&preg, regExp, REG_NOSUB) != 0)
	return match;
    match = regexec(&preg, string, (size_t)0, NULL, 0);
    regfree(&preg);
    return (!match);
}

slxPAR_TYPE utilDetermineType(const char  *value)
{

    // Check:
    //
    //   o If it could be a logical (value = "T"|"F").
    //   o If it could be an integer.
    //   o If it could be a double.
    //   o Otherwise we assume a string.
    slxVALUE  val;
    strcpy(val, value);
    slxTrimString(val, " \t");
    
    // String?
    if (*val == '\0')
	return slxSTRING;

    // Logical?
    if ((strcmp(val, "T") == 0) || (strcmp(val, "F") == 0))
	return slxLOGICAL;

    // Integer?
    int intVal = 0;
    sscanf(val, "%d", &intVal);
    slxVALUE  tstBuf;
    sprintf(tstBuf, "%d", intVal);
    if (strcmp(tstBuf, val) == 0)
	return slxINTEGER;

    // Double?
    double dblVal;
    char   *endPtr;
    dblVal = strtod(val, &endPtr);
    if (endPtr != NULL)
	{
	int len;
	if ((len = strlen(endPtr)) > 0)
	    {
	    char  tmpBuf[len + 1];
	    strcpy(tmpBuf, endPtr);
	    slxTrimString(tmpBuf, " \t");
	    if (*tmpBuf == '\0')
		return slxDOUBLE;
	    }
	else
	    return slxDOUBLE;
	}
    else
	return slxDOUBLE;

    return slxSTRING;
}

char        *utilSlxType2Str(const slxPAR_TYPE  type)
{
    if (type == slxSTRING)
	return "string";
    else if (type == slxLOGICAL)
	return "logical";
    else if (type == slxINTEGER)
	return "integer";
    else if (type == slxDOUBLE)
	return "double";
    else
	return "unknown";
}

utilLOGICAL  utilStr2Logical(const char  *str)
{
    slxPAR_TYPE  type;
    char         *tmpBuf;

    tmpBuf = slxStrDup(str);
    slxTrimString(tmpBuf, " \t\n");
    if (*tmpBuf == 'T')
	return TRUE;
    else if (*tmpBuf == 'F')
	return FALSE;
    else 
	{
	type = utilDetermineType(tmpBuf);
	if (type == slxINTEGER)
	    {
	    if (atoi(tmpBuf) == 0)
		return FALSE;
	    else
		return TRUE;
	    }
	else if (type == slxDOUBLE)
	    {
	    if (atof(tmpBuf) == 0)
		return FALSE;
	    else
		return TRUE;
	    }
	else
	    return FALSE;
	}
}

// Returns 0 at success and 1 at failure.
utilSTAT utilSplit(const char       *separators, 
		   const char       *stringPtr, 
		   const int        maxNoOfSubStr, 
		   slxKEYW_LINE     subStrings[], 
		   int              *noOfSubStr)
{
    ccsERROR error; memset(&error, 0, sizeof(ccsERROR));
    
    vltINT32 noOfSubStrLoc;
    if (slxSplit(separators, stringPtr, maxNoOfSubStr, subStrings,
		 &noOfSubStrLoc, &error) == FAILURE)
	return FAILURE;
    *noOfSubStr = noOfSubStrLoc;

    return SUCCESS;
}

/*___oOo___*/
