#ifndef slxSearchUtils_H
#define slxSearchUtils_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: slxSearchUtils.h,v 1.145 2005/07/27 08:57:27 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  04/10/96  created
* epozna    22/01/01  added slxGetDirInfo2 (VLTSW20000555)
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifdef __cplusplus
extern "C" {
#endif

#include "slxBasics.h"
#include "slxStringList.h"


ccsCOMPL_STAT slxLocateSetupFile(const slxFILENAME  setupFileName,
                                 slxFILENAME        completeName,
                                 ccsERROR           *error);

ccsCOMPL_STAT slxLocateFile(const char         *envVar,
                            const slxFILENAME  fileName,
                            slxFILENAME        completeName,
                            ccsERROR           *error);

ccsCOMPL_STAT slxGetDirInfo(slxFILENAME     dirName,
			    slxSTRING_LIST  *entryList,
			    vltINT32        *noOfEntries,
			    ccsERROR        *error);

ccsCOMPL_STAT slxGetDirInfo2(slxFILENAME     dirName,
			    slxSTRING_LIST  *entryList,
			    vltINT32        *noOfEntries,
			    ccsERROR        *error,
			     vltLOGICAL      isDirErrReport);

ccsCOMPL_STAT slxSearchSetupFile(const slxFILENAME    baseName,
				 vltINT32             *numberFound,
				 slxSTRING_LIST       *fileList,
				 const vltLOGICAL     globalSearch,
				 const vltLOGICAL     stopFirstOccur,
				 const vltLOGICAL     skipInsUserDir,
				 ccsERROR             *error);

ccsCOMPL_STAT slxSearchUserFile(const slxFILENAME    baseName,
				vltINT32             *numberFound,
				slxSTRING_LIST       *fileList,
				const vltLOGICAL     globalSearch,
				const vltLOGICAL     stopFirstOccur,
				const vltLOGICAL     skipInsUserDir,
				ccsERROR             *error);

ccsCOMPL_STAT slxSearchConfigFile(const slxFILENAME      baseName,
				  vltINT32               *numberFound,
				  slxSTRING_LIST         *fileList,
				  const vltLOGICAL       globalSearch,
				  const vltLOGICAL       stopFirstOccur,
				  const vltLOGICAL       skipInsUserDir,
				  const char             *pathEnvVar,
				  ccsERROR               *error);

ccsCOMPL_STAT slxSearchFitsFile(const slxFILENAME      baseName,
				vltINT32               *numberFound,
				slxSTRING_LIST         *fileList,
				const vltLOGICAL       globalSearch,
				const vltLOGICAL       stopFirstOccur,
				const vltLOGICAL       skipInsUserDir,
				const char             *pathEnvVar,
				ccsERROR               *error);

ccsCOMPL_STAT slxSearchDictionary(const slxDICTIONARY  dictionary,
				  slxFILENAME          pafDicFullName,
				  ccsERROR             *error);

ccsCOMPL_STAT slxSearchTemplateFile(const slxFILENAME         baseName,
				    const slxTEMPLATE_FILES   fileType,
				    vltINT32                  *numberFound,
				    slxSTRING_LIST            *fileList,
				    const vltLOGICAL          globalSearch,
				    const vltLOGICAL          stopFirstOccur,
				    const vltLOGICAL          skipInsUserDir,
				    const char                *pathEnvVar,
				    ccsERROR                  *error);

#ifdef __cplusplus
}
#endif


#endif /*!slxSearchUtils_H*/
