/******************************************************************************
* E.S.O. - VLT project
*
* slxFreeDictionary.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  02/04/96  created
*/

/************************************************************************
*   NAME
*   slxFreeDictionary - free a dictionary loaded into a MISC Hash Table
* 
*   SYNOPSIS
*   #include "slx.h"
*
*   ccsCOMPL_STAT slxFreeDictionary(miscHASH_TABLE  dicHashTable,
*                                   ccsERROR        *error)
*
*   DESCRIPTION
*   Free the memory occupied by a Dictionary loaded into a MISC Hash Table.
*
*   FILES
*                  
*   RETURN VALUES 
*
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: slxFreeDictionary.c,v 1.145 2005/07/27 09:13:20 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

/* System Headers
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* Local Headers
 */
#include "slx.h"


/* Function definition
 */
ccsCOMPL_STAT slxFreeDictionary(miscHASH_TABLE  dicHashTable,
				ccsERROR        *error)
{
    slxDIC_HANDLE      *element;


    if (miscHashGetSeq(dicHashTable, TRUE, (void **)&element,error) == FAILURE)
	return FAILURE;
    do
	{
	if (miscHashGetSeq(dicHashTable, FALSE, (void **)&element, 
			   error) == FAILURE)
	    return FAILURE;
	if (element != NULL)
	    {
	    if (slxResetDicRecord(element, error) == FAILURE)
		return FAILURE;
	    }
	}
    while (element != NULL);

    /* Now we can delete the table
     */
    miscHashDeleteTable(dicHashTable);

    return SUCCESS;
}

/*
 *****************************************************************************
 */

/*___oOo___*/
