SIMPLE  =                    T          / Standard FITS format (rev feb 1985)
BITPIX  =                   16          / 2 byte twos-compl integers (16 bits)
NAXIS   =                    2          / 2 axis (two dimensions)
NAXIS1  =                  501          / # pixels/row
NAXIS2  =                  501          / # rows (also # scan lines)
ORIGIN  = 'ESO-IHAP'                    / European Southern Observatory
DATE    = '21/06/94'                    / Date this tape written dd/mm/yy
CRVAL1  =                 750.          / Coordn first pixel in row (x-start)
CRPIX1  =                   1.          / Always referenced to first pixel in x
CDELT1  =                   1.          / Increment along x  (x-step)
CRVAL2  =                 750.          / Coordn first row (y-start)
CRPIX2  =                   1.          / Always referenced to first row (y)
CDELT2  =                   1.          / Increment along y  (y-step)
COMMENT IP_FILE 'IHAP/FITS/EM9406210142255.FITS::USER ' / IHAP: Begin of keyword
BSCALE  =          1.0                      / Real=Tape*BSCALE+BZERO
BZERO   =      32768.0                      / Real=Tape*BSCALE+BZERO
TELESCOP= 'ESONTTB '                        / ESO NTT focus B
INSTRUME= 'EMMI    '                        / Instrument used
OBSERVER= 'CLAESKENS'                       / Name of the observer
DATE-OBS= '21/06/94'                        / Date of observation (UT)
MJD-OBS =  49524.07112                      / Start of observ.=940621.014225
EXPTIME =       180.00                      / Total integration time
OBJECT  = 'PKS1318/R/3M'                    / Original target
RA      =    200.26494                      / Tel. apparent pos. at start (deg)
DEC     =     11.14320                      / Tel. apparent pos. at start (deg)
AIRMASS =      1.45118                      / Averaged air mass
COMMENT / Time Reference System is used only for Sidereal time
COMMENT / All other time info is got from instr. computer clock
HIERARCH ESO GEN ID          = 'ARC-0001/1.4' / Version of related document
HIERARCH ESO GEN PROJ ID     = '053.00-000' / ESO program identification
HIERARCH ESO GEN EXPO NO     =         7487 / Image Sequence Number
HIERARCH ESO GEN EXPO TYPE   = 'SCI     '   / Type of exposure
HIERARCH ESO GEN EXPO LST    =       53707. / Loc. Sid. time at start of ex.
HIERARCH ESO GEN TEMP        =        281.8 / Observatory Ambient Temp. (K)
HIERARCH ESO GEN TEMPVAR     =          0.0 / Observatory Temp. var. (K)
HIERARCH ESO GEN RHUM        =         25.0 / Observatory Ambient Humidity (%)
HIERARCH ESO GEN RHUMVAR     =          0.0 / Observatory Humidity var. (%)
HIERARCH ESO GEN FWHM        =         0.00 / Observatory seeing (arcsec)
HIERARCH ESO GEN FWHMVAR     =         0.00 / Observatory seeing var. (arcsec)
HIERARCH ESO GEN WIND SPEED  =          4.0 / Observatory wind speed (m/sec)
HIERARCH ESO GEN WIND SPEEDVA=         -.10 / Observ. wind speed var. (m/sec)
HIERARCH ESO GEN WIND DIREC  =         17.0 / Wind direction (N=0 E=90)
HIERARCH ESO GEN WIND DIRVAR =       -11.00 / Wind direction var.
HIERARCH ESO TEL ID          = 'ESONTT  '   / Telescope Identification
HIERARCH ESO TEL FOCU ID     = 'NASM-B  '   / Telescope focus ID
HIERARCH ESO TEL LON         =     -70.7345 / Telescope Longitude (+=East)
HIERARCH ESO TEL LAT         =     -29.2584 / Telescope Latitude (+=North)
HIERARCH ESO TEL HEIGHT      =         2440 / Telescope height (m)
HIERARCH ESO TEL FOCU LEN    =       38.482 / Focus length (m)
HIERARCH ESO TEL FOCU SCALE  =        1.489 / Focus scale (deg/m) = 5.36""/mm
HIERARCH ESO TEL TRAK RATEA  =        .0042 / Tracking rate in alpha (deg/s)
HIERARCH ESO TEL TRAK RATED  =           0. / Tracking rate in delta (deg/s)
HIERARCH ESO TEL DOME TEMP   =        281.9 / Tel temperature (Kelvin)
HIERARCH ESO TEL DOME TEMPVAR=          0.0 / Tel temp. variation (Kelvin)
HIERARCH ESO TEL DOME FWHM   =         0.00 / Tel seeing (arcsec)
HIERARCH ESO TEL DOME FWHMVAR=         0.00 / Tel seeing variation (arcsec)
HIERARCH ESO TEL PARANG START=        28.77 / Parallactic angle at exp start
HIERARCH ESO TEL PARANG END  =        29.50 / Parallactic angle at exp end
HIERARCH ESO TEL AIRM START  =      1.44654 / Airmass at exp start
HIERARCH ESO TEL AIRM END    =      1.45582 / Airmass at exp end
HIERARCH ESO ADA ID          = 'ADAPTB  '   / Adapter Identification
HIERARCH ESO ADA MODE        = 'STD     '   / Mode (standard)
HIERARCH ESO ADA POSANG      =        0.000 / Rotat. at the start of the exp.
HIERARCH ESO ADA GUID-1 X    =   -.2519E-01 / Guide probe x position (m)
HIERARCH ESO ADA GUID-1 Y    =       -.1419 / Guide probe y position (m)
HIERARCH ESO ADA GUID-2 X    =       -.1638 / Guide probe x position (m)
HIERARCH ESO ADA GUID-2 Y    =        .1653 / Guide probe y position (m)
HIERARCH ESO INS ID          = 'EMMI #1 '   / Instrument Identification
HIERARCH ESO INS COMP ID     = 'HP RTE-A V5' / Instrument computer op. sys.
HIERARCH ESO INS MODE        = 'RILD    '   / Mode EMMI is in
HIERARCH ESO INS PATH        = 'RED     '   / EMMI arm used
HIERARCH ESO INS OPTI-2 NO   =            1 / Mirror Wheel position
HIERARCH ESO INS OPTI-2 TYPE = 'MIRROR  '   / What is this element
HIERARCH ESO INS OPTI-2 ID   = 'RILD MIR'   / Mirror unique identification
HIERARCH ESO INS OPTI-2 NAME = 'RILD    '   / Mirror position
HIERARCH ESO INS OPTI-3 NO   =            1 / LD Slits Wheel position
HIERARCH ESO INS OPTI-3 TYPE = 'FREE    '   / What is this element
HIERARCH ESO INS MIRR-3 NAME = 'UPPER RED'  / Upper folding mirror red
HIERARCH ESO INS MIRR-3 ST   =            F / Mirror IN when true
HIERARCH ESO INS OPTI-7 NO   =            4 / Filter Wheel red position
HIERARCH ESO INS OPTI-7 TYPE = 'FILTER  '   / What is this element
HIERARCH ESO INS OPTI-7 ID   = '#608   *'   / Filter unique identification
HIERARCH ESO INS OPTI-7 NAME = 'R       '   / Filter position
HIERARCH ESO INS OPTI-9 NO   =            9 / Grism Wheel position
HIERARCH ESO INS OPTI-9 TYPE = 'FREE    '   / What is this element
HIERARCH ESO INS FOCU ENC    =         8095 / Red focus unit encoder value
HIERARCH ESO INS FOCU MODE   = 'USER    '   / Red camera focus determination
HIERARCH ESO DET NAME        = 'TK2048EB'   / Detector name
HIERARCH ESO DET ID          = 'ccd$36'     / Detector serial id.
HIERARCH ESO DET TYPE        = 'CCD Tektronix' / Detector type
HIERARCH ESO DET PIXSIZE     =      24.E-06 / Size of pixel (m)
HIERARCH ESO DET BITS        =           16 / ADU bits per pixel
HIERARCH ESO DET FRAM BITS   =           16 / Number of bits/pixel transfered
HIERARCH ESO DET FRAM NAXIS1 =          501 / Number of pixels along x
HIERARCH ESO DET FRAM CRVAL1 =        750.0 / x coordinate of lower left pixel
HIERARCH ESO DET FRAM CRPIX1 =          1.0 / x coordinate of reference pixel
HIERARCH ESO DET FRAM CDELT1 =          1.0 / Binning factor along x
HIERARCH ESO DET FRAM NAXIS2 =          501 / Number of pixels along y
HIERARCH ESO DET FRAM CRVAL2 =        750.0 / y coordinate of lower left pixel
HIERARCH ESO DET FRAM CRPIX2 =          1.0 / y coordinate of reference pixel
HIERARCH ESO DET FRAM CDELT2 =          1.0 / Binning factor along y
HIERARCH ESO DET DKTIME      =       180.00 / Dark current time (s)
HIERARCH ESO DET TEMP-VAR    =          0.0 / Temperature drift during exposure
HIERARCH ESO DET TEMPMEAN    =        152.1 / Mean detector temperature (K)
HIERARCH ESO DET COMP ID     = 'ccdr-V4.1'  / A900 CCD-program name+vers
HIERARCH ESO DET PARM1       = 'CLOCK=tek2k36admpp'
HIERARCH ESO DET PARM2       = 'VLO1 :  -8.05    VHI1 :   3.01    VDD1 :  23.51'
HIERARCH ESO DET PARM3       = 'VLO2 :  -8.05    VHI2 :   3.01    VDD2 :  23.78'
HIERARCH ESO DET PARM4       = 'HLO1 :  -4.06    HHI1 :   5.99    VDR1 :  13.77'
HIERARCH ESO DET PARM5       = 'HLO2 :  -4.08    HHI2 :   5.99    VDR2 :  14.09'
HIERARCH ESO DET PARM6       = 'RLO1 :  -0.37    RHI1 :  11.99    VGS1 :  -0.31'
HIERARCH ESO DET PARM7       = 'VLO3 :  -8.10    VHI3 :   6.00    VGS2 :  -9.28'
HIERARCH ESO DET PARM8       = '-15V : -14.72    +15V :  14.80    +30V :  27.32'
HIERARCH ESO DET DATE        = '04/02/93'   / CCD implementation date
HIERARCH ESO DET MODE        = 'SLOW    '   / Readout mode
HIERARCH ESO DET OUTPUTS     =            2 / On-chip outputs connected
HIERARCH ESO DET OUT-1 ST    =            F / If T, output enabled
HIERARCH ESO DET OUT-2 ST    =            T / If T, output enabled
HIERARCH ESO DET OUT-2 X     =         2086 / X-location for output 2
HIERARCH ESO DET OUT-2 Y     =         2046 / Y-location for output 2
HIERARCH ESO DET OUT-2 GAIN  =            2 / Gain for output 2
HIERARCH ESO DET OUT-2 ADU   =        1.400 / Electrons per ADU for output 2
HIERARCH ESO DET OUTREF      =            2 / Ref. output (gives image orient.)
HIERARCH ESO DET UDIT        =       180.00 / User defined integr. time (sec)
HIERARCH ESO DET SHUT TMOPEN =          .86 / Time needed to open shutter(sec)
HIERARCH ESO DET SHUT TMCLOS =          .91 / Time needed to close shutter(sec)
ESO-LOG  00:00:00> DATE         = '1994-06-21'  / Tue Jun 21, 1994
ESO-LOG  01:42:24>-START EXPO EMMI RED          / Start exp. on CCD EMMI RED
ESO-LOG  01:42:25> EXPO EMMI RED NO = 7487      / Exp. num. on CCD EMMI RED
ESO-LOG  01:45:26>-STOP EXPO EMMI RED           / Stop exp. on CCD EMMI RED
COMMENT IP_FEND                         / IHAP: End of keyword file
COMMENT EXPTIME 180.000
COMMENT IP_CBEND                        / IHAP: comment block end
HIERARCH ESO ARC DATAMIN    =       32768. / Minimal pixel value 
HIERARCH ESO ARC DATAMAX    =       97765. / Maximal pixel value 
HIERARCH ESO ARC DATAMEAN   =      78773.6 / Mean pixel value 
HIERARCH ESO ARC DATASIGMA  =      438.255 / Standard deviation 
HIERARCH ESO ARC DATANOISE  =        0.000 / Noise level = noisy/total bitplanes
HIERARCH ESO ARC CHECKSUM   =    771631559 / File CRC (32 bit CCITT)
END
