#!/usr/local/bin/tcl
#**************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: slxSplitFits2.test.tcl,v 1.145 2005/07/27 11:15:12 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ---------------------------------------------
# jknudstr  09/04/96  created
#

#**************************************************************************
#   NAME
#   slxSplitFits2.test.prog - test program for slxSplitFits2
#
#   SYNOPSIS
#   slxSplitFits2.test.prog
#
#   DESCRIPTION
#
#-----------------------------------------------------------------------------

# Take over Ousterhout's test procedure 
source ../test/defs

#set VERBOSE 1

# testP is the name of the binary we use for testing our function
set testP ../bin/slxTestSplitFits2


# In case of errors, exec $testP does an exit(1), so from Tcl
# we have to catch this error


# PART 2: functionality test
# ==========================
test slxSplitFITS-2.1 {parameter with string value} {
	set string {"HIERARCH ESO cat subsystem1 subsystem2 parameter=         'any string '\
	            / comment           "}
	catch "exec $testP $string" msg
	set msg
}  {{cat} {subsystem1} {subsystem2} {parameter} {'any string '} {comment           }}

test slxSplitFITS-2.2 {parameter with logical value} {
	set string {"HIERARCH ESO cat subsystem1 subsystem2 parameter=                    T \
	            / comment           "}
	catch "exec $testP $string" msg
	set msg
}  {{cat} {subsystem1} {subsystem2} {parameter} {T} {comment           }}

test slxSplitFITS-2.3 {parameter with integer value} {
	set string {"HIERARCH ESO cat subsystem1 subsystem2 parameter=              1234567 \
	            / comment           "}
	catch "exec $testP $string" msg
	set msg
}  {{cat} {subsystem1} {subsystem2} {parameter} {1234567} {comment           }}

test slxSplitFITS-2.4 {parameter with double value} {
	set string {"HIERARCH ESO cat subsystem1 subsystem2 parameter=           123.456789 \
	            / comment           "}
	catch "exec $testP $string" msg
	set msg
}  {{cat} {subsystem1} {subsystem2} {parameter} {123.456789} {comment           }}



