#!/bin/sh
# Define which version of the sequencer to use \
  exec seqWish -f "$0"  ${1+"$@"}
#
#*************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: slxTclTest.pan,v 1.145 2005/07/27 10:42:27 vltsccm Exp $" 
#
# slxTclTest.pan
#
# This file has been produced by the panel editor
#   version: panel.tcl,v 2.49
#   date   : Fri Dec 15 11:59:06 MEZ 1995
#
#      !!!!!!!!!!  DO NOT MANUALLY EDIT THIS FILE  !!!!!!!!! 
#
#--------------------------------------------------------------
# 
#  Get directory root of VLT, integration, current module. 

global gvar  cv bcv actAreaHeight shArea panClassLib 
global panWidget panWidgetHlp panDbData panUsrProcs panUsrLib
global menu menuItem rootMenu ckMenuBar ckActBut ckShHelp ckCCS
global argv0 auto_path env VLTROOT INTROOT HOME 

if {[catch {set VLTROOT $env(VLTROOT)}]} {set VLTROOT undefined}
if {[catch {set INTROOT $env(INTROOT)}]} {set INTROOT undefined}
if {[catch {set HOME    $env(HOME)}   ]} {set HOME    undefined}
# 
# Set auto_path 
# 

if { [file exist ../lib/libpanPublic.tcl] } { 
   lappend auto_path ../lib/libpanPublic.tcl
} elseif { [file exist $INTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $INTROOT/lib/libpanPublic.tcl
} elseif { [file exist $VLTROOT/lib/libpanPublic.tcl ] } { 
   lappend auto_path $VLTROOT/lib/libpanPublic.tcl 
} else {
   puts stderr "panel EXITS : Tcl library libpanPublic.tcl not found " 
   exit 1
}

#
# Link panel to user libraries 
#

set panUsrLib   libslxTcl.tcl  
set panClassLib libslxTclTestGui

panSetAutoPath  $panUsrLib $panClassLib 

if {[info exists EDITING]} { 
   set panRoot .slxTclTest 
   set panUsrProcs {slxTclTestInit slxTclTestExit slxTclTestGlobalData slxSaveAs slxLoadFrom}
   set argc 0 ; set argv {}
   set par(PANELX) 390
   set par(PANELY) -2
} else {
   set par(MY_NAME) [file tail $argv0] 
   set colordef winter
   set EDITING 0
   panReadOption
   set tk_strictMotif 0
   setPublicVar
   set panRoot . 
}

#
# User's defined global data 
#

proc slxTclTestGlobalData { } {                                                                                                            

 # Declare any variable as global

 # global <var>

 # Variable Initialization

 #  set <var> <value>

 #set commonly used variables

 #ccdUsrGlobalData  
}



#
# User's defined Initialization Procedure
#

proc slxTclTestInit { } {                                                                                                      

 # Declare global variables 

   global <var> 

 # User Initialization

   set <var> <value> ; # comment ..  
}



#
#-----------------------------------------------
#            Widget Definition  
#-----------------------------------------------
# 

set ckShHelp      1; # Set Short Help
set ckActBut      2; # Set Action Button Area
set ckMenuBar     1; # Setup Menu Bar
set ckCCS         1; # Initialize CCS
set ckCmdReply    0;  # Display Cmd. Reply
set actAreaHeight 50; # Set height of action area 

panInit        $argc $argv;            # Initialization
panCreateFrame slxTclTest 390 -2;  # Create empty frame
panGetCvNames  slxTclTest cv bcv; # Get Canvas Names 

slxTclTestArm_uifClass  $cv.blueArm -library libslxTclTestGui.tcl -cwp {} \
                   -canvasAnchor nw -relief raised
UifCheckButton     $cv.blueSelect -offVal a -onVal r -label {Blue Arm} \
                   -width 0 -variable gvar(blueArm) \
                   -command {slxTclFilterSetup $gvar(blueArm) blueArm*} \
                   -canvasAnchor nw
UifCheckButton     $cv.dictionary -offVal none -onVal slxTclDidTemplate \
                   -label dictionary -width 8 -variable gvar(dictionary) \
                   -canvasAnchor nw
UifEntry           $cv.file -maxVal 0 -minVal 0 -variable gvar(file) \
                   -width 15 -canvasAnchor nw
UifActionButton    $bcv.load -label Load -stateVar gvar(dummy) -width 12 \
                   -state normal -font *adobe-helvetica-bold-r-*-*-14* \
                   -command {global cv ; slxLoadFrom $gvar(file) ; panUpdateCanvas $cv} \
                   -canvasAnchor center
UifOptionButton    $cv.method -itemList {uncompressed compressed both none} \
                   -default uncompressed \
                   -variable gvar(setup.3.DET.FRAM21.FITSMTD) -length 12 \
                   -canvasAnchor nw
slxTclTestArm_uifClass  $cv.redArm -library libslxTclTestGui.tcl -cwp {} \
                   -canvasAnchor nw -relief raised
UifCheckButton     $cv.redSelect -offVal a -onVal r -label {Red Arm} \
                   -width 0 -variable gvar(redArm) \
                   -command {slxTclFilterSetup $gvar(redArm) redArm*} \
                   -canvasAnchor nw
UifActionButton    $bcv.save -label Save -stateVar gvar(0) -width 12 \
                   -state normal -font *adobe-helvetica-bold-r-*-*-14* \
                   -command {slxSaveAs $gvar(dictionary) $gvar(template) $gvar(file)} \
                   -canvasAnchor center
slxTclTestCommon_uifClass  $cv.setupCommon -library libslxTclTestGui.tcl \
                   -cwp {} -canvasAnchor nw -relief raised
UifCheckButton     $cv.simple -offVal F -onVal T -label SIMPLE -width 6 \
                   -variable gvar(setup.0.SIMPLE) -canvasAnchor nw
UifOutput          $cv.slxTclTest-wdg1 -evtFilter w -dbMode dbPoll \
                   -variable gvar(dictionary) -color Black -frame 1 \
                   -width 17 -font -Adobe-courier-medium-r-normal--14* \
                   -canvasAnchor nw
UifOutput          $cv.slxTclTest-wdg2 -evtFilter w -dbMode dbPoll \
                   -variable gvar(template) -color Black -frame 1 -width 17 \
                   -font -Adobe-courier-medium-r-normal--14* \
                   -canvasAnchor nw
UifOutput          $cv.slxTclTest-wdg3 -evtFilter w -dbMode dbPoll \
                   -variable gvar(setup.0.SIMPLE) -color Black -frame 1 \
                   -width 1 -font -Adobe-courier-medium-r-normal--14* \
                   -canvasAnchor nw
UifFrame           $cv.slxTclTest-wdg4 -width 1000 -height 1 \
                   -canvasAnchor nw
UifFrame           $cv.slxTclTest-wdg5 -width 400 -height 10 \
                   -canvasAnchor nw
UifCheckButton     $cv.template -offVal none -onVal slxTclHdTemplate \
                   -label template -width 8 -variable gvar(template) \
                   -canvasAnchor nw

#
#  Canvas Items
#

$cv create text 26 313 -tags "text slxTclTest-item1" -anchor nw \
          -text "File name" \
          -fill black -font -Adobe-helvetica-medium-r-normal--14* 


#
# Set Widget Configuration
#
set panWidget(blueArm)  {UifClass 230 147 1 0 0 nw 0 {} 0}
set panWidget(blueSelect)  {UifCheckButton 284 122 1 0 r 0 0 blueArm 0 0 1 0 0 0}
set panWidget(dictionary)  {UifCheckButton 10 249 1 0 none 0 0 dictionary 0 0 1 0 0 0}
set panWidget(file)  {UifEntry 104 310 1 0 aaa 0 0 file 0 A {} {} 0 0 0 0}
set panWidget(load)  {UifActionButton 385 27 1 0 0 0 0 dummy 0 {} gvar(dummy)}
set panWidget(method)  {UifOptionButton 28 6 1 0 uncompressed 0 0 setup.3.DET.FRAM21.FITSMTD 0 {}}
set panWidget(redArm)  {UifClass 9 148 1 0 0 nw 0 {} 0}
set panWidget(redSelect)  {UifCheckButton 70 120 1 0 r 0 0 redArm 0 0 1 0 0 0}
set panWidget(save)  {UifActionButton 60 25 1 0 0 0 0 0 0 {} gvar(dummy)}
set panWidget(setupCommon)  {UifClass 144 48 1 0 0 nw 0 {} 0}
set panWidget(simple)  {UifCheckButton 297 2 1 0 T 0 0 setup.0.SIMPLE 0 0 1 0 0 0}
set panWidget(slxTclTest-wdg1)  {UifOutput 102 252 1 0 0 0 0 dictionary 0 {} {}}
set panWidget(slxTclTest-wdg2)  {UifOutput 103 278 1 0 0 0 0 template 0 {} {}}
set panWidget(slxTclTest-wdg3)  {UifOutput 376 2 1 0 0 0 0 setup.0.SIMPLE 0 {} {}}
set panWidget(slxTclTest-wdg4)  {UifFrame 372 54 1 0 0 0 0 gvar(slxTclTest-wdg15) 0 0}
set panWidget(slxTclTest-wdg5)  {UifFrame 19 230 1 0 0 0 0 gvar(slxTclTest-wdg16) 0 0}
set panWidget(template)  {UifCheckButton 10 277 1 0 none 0 0 template 0 0 1 0 0 0}

#
# Set Database Configuration
#

#
# Set Short Help for each widget
#
set panWidgetHlp(blueSelect)  {Enable/Disable variables associated to the blue arm}
set panWidgetHlp(dictionary)  {use data dictionary to save setup}
set panWidgetHlp(method)  {setup keyword DET FRAMi FITSMTD}
set panWidgetHlp(redSelect)  {Enable/disable variables associated to the red arm}
set panWidgetHlp(save)  {Save displayed setup in a file}
set panWidgetHlp(simple)  {setup keyword SIMPLE}
set panWidgetHlp(template)  {use template to build setup file header}

#
#-----------------------------------------------
#           Menu Bar Definition  
#-----------------------------------------------
# 

set sepCounter 0
set rootMenu   { file help }

#
# Sub-Menu definition
#
set menu(file)  { File  1 0 {quit} }
set menu(help)  { Help  1 0 {extended_help }    }

#
# Define menu buttons 
#
set menuItem(file.quit)  { {Quit}           1 cmd  {panClosePanel} }
set menuItem(help.extended_help)  { {Extended Help}  1 cmd  {puts "Not Implemented"} }

#
#-----------------------------------------------
#            Create the Panel  
#-----------------------------------------------
#

wm geometry  $panRoot 447x457
wm title     $panRoot "slxTclTest"
set par(TITLE) "slxTclTest" 

panMainStart  slxTclTest $argc $argv

#--------------------    End of Main   --------------------



#####################################################
#           Definition of Local Procedures
#####################################################


proc slxTclTestExit { } {                                                                                                      

 # Declare global variables 

   global <var> 

 # Statements to be executed when exiting

    
}


proc slxSaveAs { dictionary template file } {                                                                    

   if {[string match $dictionary "none"]} {
       set dictionary ""
   }
   if {[string match $template "none"]} {
       set template ""
   }
   # select file
   if {$file == ""} {
      set file [panSelectFile "." "*.stp"]
   }

   # save panel in setup file
   if {$file != ""} {
      # replace keywords for blue arm
      slxTclFilterSetup c blueArm* .DET 0.DET1
      slxTclSaveSetup $file $dictionary $template
   }
}


proc slxLoadFrom { file } {                                                                  

   # select file
   if {$file == ""} {
       set file [panSelectFile "." ""]
   }

   # load setup file in panel
   if {$file != ""} {
      slxTclFilterSetup c blueArm* .DET 0.DET1
      slxTclLoadSetup $file
   }
}
