/******************************************************************************
* E.S.O. - VLT project
*
* slxTestAliasToShortFITS.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  20/09/94  Created 1. version
* epozna    30/07/02  comp warnings: exit->return
*/

/************************************************************************
*   NAME
*   slxTestAliasToSHortFITS - test program for slxAliasToShortFITS()
* 
*   SYNOPSIS
*   slxTestAliasToSHortFITS
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"


static char *rcsId="@(#) $Id: slxTestAliasToShortFITS.c,v 1.145 2005/07/27 11:52:24 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


/*
 * System Headers 
 */

#include <stdlib.h>
#include <string.h>


/*
 * Local Headers 
 */

#include "slx.h"


/* 
 * Main
 */

int main (int argc, char *argv[])
{
    ccsERROR     error;
    ccsPROCNAME  procName;
    char         shortFITS[81];
    char         testStrings[30][32];
    char         tableName[32];
    int          n;

    strcpy(procName, "slxTestAlias2SF");
    if (ccsInit(procName, 0, NULL, NULL, &error) == FAILURE)
        return(1);

    strcpy((char *)testStrings[0], "#ISAAC");
    strcpy((char *)testStrings[1], "alias2");
    strcpy((char *)testStrings[2], "alias7");
    strcpy((char *)testStrings[3], "alias5");
    strcpy((char *)testStrings[4], "alias1");
    strcpy((char *)testStrings[5], "#UVES");
    strcpy((char *)testStrings[6], "kalias4");
    strcpy((char *)testStrings[7], "alias1");
    strcpy((char *)testStrings[8], "Falias1");
    strcpy((char *)testStrings[9], "ualias7");
    strcpy((char *)testStrings[10], "Talias6");
    strcpy((char *)testStrings[11], "#FORS");
    strcpy((char *)testStrings[12], "kalias4");
    strcpy((char *)testStrings[13], "Talias6");
    strcpy((char *)testStrings[11], "#FORS");
    strcpy((char *)testStrings[12], "yalias3");
    strcpy((char *)testStrings[13], "5alias2");
    strcpy((char *)testStrings[14], "#ISAAC");
    strcpy((char *)testStrings[15], "alias1");
    strcpy((char *)testStrings[16], "alias70");
    strcpy((char *)testStrings[17], "alias3");
    strcpy((char *)testStrings[18], "alias111");
    strcpy((char *)testStrings[19], "#UVES");
    strcpy((char *)testStrings[20], "xxxx");
    strcpy((char *)testStrings[21], "alias1");
    strcpy((char *)testStrings[22], "yalias3");
    strcpy((char *)testStrings[23], "kalias4");
    strcpy((char *)testStrings[24], "Talias6");
    strcpy((char *)testStrings[25], "#FORS");
    strcpy((char *)testStrings[26], "ualias");
    strcpy((char *)testStrings[27], "Lalias5");
    strcpy((char *)testStrings[28], "vvvvv");
    strcpy((char *)testStrings[29], "#NONEXIST");

    for (n = 0; n < 30; n++)
        {
        if (*testStrings[n] == '#')
            {
	    sprintf(tableName, "%s%s", (testStrings[n] + 1), ".alias");
            printf("\n\nLoading new Alias Conversion Table: %s", tableName);
            if (slxAliasToShortFITS(testStrings[n], ccsTRUE, 
                                    tableName, shortFITS,
                                    &error) != SUCCESS)
		{
		errResetStack(&error);
                printf("\nError in creating/loading the hash table");
		}
            }
        else 
            {
            if (slxAliasToShortFITS(testStrings[n], ccsFALSE, "", shortFITS,
                                    &error) != SUCCESS)
		{
		errResetStack(&error);
                printf("\nError in converting the alias: %s", 
                       testStrings[n]);
		}
            else
                printf("\nAlias %s is %s", testStrings[n], shortFITS);
            }
        }
    printf("\n\n");
    ccsExit(&error);
    return(0);
}





