/*******************************************************************************
* E.S.O. - VLT project
*
* slxTestDynBuf .c
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna    31/07/02  added test 1.6 for VLTSW20000108 (file end with comments)
* epozna    18/09/02  updated to linux (fixed bug in the test case)
*/

/************************************************************************
*   NAME
*   slxTestDynBuf - load a file into a Dyn Buffer and check the buffer
* 
*   SYNOPSIS
*   slxTestDynBuf
* 
*   DESCRIPTION
*
*   ENVIRONMENT
*
*   RETURN VALUES
*
*   EXAMPLES
*
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: slxTestDynBuf.c,v 1.145 2005/07/27 12:24:15 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


#include <string.h>
/* Local Headers 
 */
#include "slx.h"
#include "slxTest.h"

/* Local functions
 */
int printDynBuffer(slxDYN_BUF dynBuf,ccsERROR* stack);
int checkDynBuffer(slxDYN_BUF * dynBuf,ccsERROR* stack);

/* Main
 */
int main (int argc, char *argv[])
{
    
    /* 
     * VLTSW20000108 
     */
    slxDYN_BUF dynBuf;
    ccsERROR stack; 
    char * newline="E";
 
    errResetStack(&stack);
 
    /* Check input parameters
     */
    if (argc >1 )
	{
	printf("\nCorrect syntax is: \n\n");
	printf("slxTestDynBuf \n\n");
	return(1);
	}

    /* --------------------------
     * Init dynamic buffer
     * --------------------------
     */
 
    slxInitDynBuf(&dynBuf, &stack); 

  
    /* ------------------------------------- 
     * Load a file with a comment at the end
     * --------------------------------------
     */ 

    /* LINUX- specify filename as type slxFILENAME
     */
    slxFILENAME file="slxTestDynByf.bs";
    if (slxLoadFile(file, "", &dynBuf, &stack) == FAILURE)
	{ 
	printf("could not load file\n");
	return(1);
	}

    /* -----------------
     * check the buffer
     * -----------------
     */
    printf("'%s'\n",dynBuf.dynBuf); 
    /*printf(".   .   .   .   .   .   .   .   .  .   .   .  \n");*/
    
    /*checkDynBuffer(&dynBuf,&stack);*/

    /* -------------------------------------------------------------
     * Add a character 'E' at the end of the buffer and check buffer
     * --------------------------------------------------------------
     */
  
    slxStoreBufDynBuf(&dynBuf,newline,strlen(newline),&stack);
    printf("'%s'\n",dynBuf.dynBuf); 
    /*printf(".   .   .   .   .   .   .   .   .  .   .   .  \n");*/
 
    /*checkDynBuffer(&dynBuf,&stack);*/


    /* -------------------------------------------------------------
     * Add a string '\nHELLO' at the end of the buffer and check buffer
     * --------------------------------------------------------------
     */
     char* newline1="\nHELLO"; 
     slxStoreBufDynBuf(&dynBuf,newline1,strlen(newline1),&stack);
    
     printf("'%s'\n",dynBuf.dynBuf);
    /*printf(".   .   .   .   .   .   .   .   .  .   .   .  \n");*/
  

    /*checkDynBuffer(&dynBuf,&stack);*/

    slxResetDynBuf(&dynBuf, &stack);

    return(0);
}





  
int printDynBuffer(slxDYN_BUF dynBuf,ccsERROR* stack)
{
   
   char * keywordLine;
   
   do
     {
       if (slxGetNextLineBuf2(&dynBuf, slxDO_NOT_INIT ,
			      &keywordLine, stack)!= SUCCESS)
	 {
	   printf("error\n");
	   return 1;
	 }
       printf("keywordline: <%s>\n", keywordLine);
     }
   while (strlen(keywordLine)!=0 );
   printf("- - - - - - - - - - - - - - - - - - - - - - - - - - - \n");
   return 0;
}
 
int checkDynBuffer(slxDYN_BUF * dynBuf,ccsERROR* stack)
{
    /*
     * This check should be performed only during development phase
     * It checks whether the buffer is correctly ended with '\0'
     */
    char *p;

    p = dynBuf->dynBuf+dynBuf->bytesAlloc; /* p = dynBuf->dynBuf+dynBuf->bytesStored+1; */
    
    /* add characters at the end of the buffer
     */
    *(++p) ='-'; *(++p) ='-'; *(++p) ='-'; *(++p) ='\n';

    /* print the buffer
     * the additionla characters should not appear!
     */
    printDynBuffer(*dynBuf,stack);
    return 0;
}
