/*******************************************************************************
* E.S.O. - VLT project
*
* slxTestLoadSaveFile.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  12/10/95  Created
* epozna    30/07/02  comp warnings: exit->return
*/

/************************************************************************
*   NAME
*   slxTestLoadSaveFile - load a file into a Dyn Buffer and save it afterwards
* 
*   SYNOPSIS
*   slxTestLoadSaveFile <env var> <load file> <save file>
* 
*   DESCRIPTION
*
*   ENVIRONMENT
*
*   RETURN VALUES
*
*   EXAMPLES
*
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: slxTestLoadSaveFile.c,v 1.145 2005/07/27 11:58:30 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


#include <string.h>
/* Local Headers 
 */
#include "slx.h"
#include "slxTest.h"

/* Main
 */
int main (int argc, char *argv[])
{
    ccsERROR          error;
    ccsPROCNAME       procName;
    slxDYN_BUF        fileHandle;
    slxFILENAME       loadFile;
    slxFILENAME       saveFile;


    /* Check input parameters
     */
    if (argc < 4)
      {
      printf("\nCorrect syntax is: \n\n");
      printf("slxTestLoadSaveFile <env var> <load file> <path/save file>\n\n");
      return(1);
      }
    
    strcpy(procName, "slxTstLdSv");
    if (ccsInit(procName, 0, NULL, NULL, &error) == FAILURE)
        {
        printf("\nError in initializing on RTAP!\n\n");
        return(1);
        }

    if (slxInitDynBuf(&fileHandle, &error) == FAILURE)
	{
	slxDumpError(&error);
	slxResetDynBuf(&fileHandle, &error);
        ccsExit(&error);
        return(1);
	}

    strcpy(loadFile, argv[2]);
    strcpy(saveFile, argv[3]);

    /* Load the file
     */
    if (slxLoadFile(loadFile, argv[1], &fileHandle, &error) == FAILURE)
	{
	slxDumpError(&error);
	slxResetDynBuf(&fileHandle, &error);
        ccsExit(&error);
        return(1);
	}

    /* Save the contents in the Save File
     */
    if (slxSaveFile(saveFile, argv[1], &fileHandle, &error) == FAILURE)
	{
	slxDumpError(&error);
	slxResetDynBuf(&fileHandle, &error);
        ccsExit(&error);
        return(1);
	}

    slxResetDynBuf(&fileHandle, &error);
    ccsExit(&error);
    return(0);
}







