/*******************************************************************************
* E.S.O. - VLT project
*
* slxParseSUPDst.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  07/09/94  Created 1. version 
*/

/************************************************************************
*   NAME
*   slxParseSUPDst - test program for the slxParSetUp() function
* 
*   SYNOPSIS
*   slxParseSUPDst [&]
* 
*   DESCRIPTION
*   The program is used to emulate a destination which can receive set-up
*   commands.
*
*   It sends back a reply to the source.
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h"


static char *rcsId="@(#) $Id: slxTestParseSUPDst.c,v 1.145 2005/07/27 12:01:20 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


/* 
 * System Headers 
 */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>


/*
 * Local Headers 
 */

#include "slx.h"
#include "slxTest.h"


/* 
 * Main
 */

int main (int argc, char *argv[])
{
    char               *sendBuf = "JUST TO SEND SOMETHING";
    char               *buffer;       
    ccsERROR           error;
    ccsERROR           errorMsg;
    ccsPROCNAME        procName;
    msgHEADER          *message;
    msgRECEIVEFILTER   msgFilter;
    msgCMD             *command;      
    msgCMD             sendCommand;
    msgCMDID           commandID;     
    msgLENGTH          bufLen;        
    msgPROCESSID       *orgID;        
    vltUINT8           msgType;       
    vltLOGICAL         lastReply;     


    strcpy(procName, "slxParseSUPDst");
    if (ccsInit(procName, 0, NULL, NULL, &error) != SUCCESS)
        {
        printf("\nslxParseSUPDest: Call to ccsInit() failed!");
        exit(1);
        }

    msgFilter.accept = msgANY_MESSAGE;
    while (1)
        {
        printf("\nslxParseSUPDest: Waiting for a message!");
	message = (msgHEADER *)NULL;
        if(msgRecvMsg(&msgFilter,
                      msgNO_TIMEOUT,
                      &message,
                      &error) != SUCCESS)
            {
            printf("\nslxParseSUPDest: Error in call to msgRecvMsg()!");
            }

        /*
         * Parse the message
         */

        if (msgParseMsg(message, &msgType, &command, &commandID, &orgID,
                        &lastReply, &buffer, &bufLen, &errorMsg,
                        &error) != SUCCESS)
            {
            printf("\nslxParseSUPDest: Error in parsing!");
            }

        /*
         * Write the set-up commands to the screen
         */
            
        printf("%s", buffer);

        if(msgSendReply(orgID, commandID, sendCommand, sendBuf, 
                        (msgLENGTH)sizeof(sendBuf),
                        ccsTRUE, &errorMsg, &error) != SUCCESS)
            {
            printf("\nslxParseSUPDest: Error sending reply!");
            }
        }    /* while (1) */

    exit(0);
}




