/******************************************************************************
* E.S.O. - VLT project
*
* slxTestSplitShortFITS.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  04/08/94  Created 1. version
*/

/************************************************************************
*   NAME
*   slxTestSplitShortFITS - Program to test slxSplitShortFITS(3)
* 
*   SYNOPSIS
*   slxTestSplitShortFITS 
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h" 


static char *rcsId="@(#) $Id: slxTestParseSetup.c,v 1.145 2005/07/27 12:02:34 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);


/* 
 * System Headers 
 */

#include <stdio.h>
#include <string.h>


/*
 * Local Headers 
 */

#include "slx.h"


/* 
 * Main
 */

int main(int argc, char *argv[])
{
    ccsERROR	error;
    ccsPROCNAME procName;
    vltLOGICAL	wait;
    msgTIMEOUT	timeout;
    vltUINT16	pending;
    int 	i;
    char	*name;
    
    /* arg 1-4 are strings */
    /* Fifth is a logical */
    sscanf (argv[5], "%d", &i);
    wait = i;

    /* Sixth is timeout: 0=NO_TIMEOUT, -1=NO_WAIT, >0 = ms */
    sscanf (argv[6], "%d", &i);
    timeout = i;
 
    /* application name is last part of pathname */
    if ((name = strrchr(argv[0],'/')) == NULL)
	{
	name = argv[0];		/* name does not contain path */
	} 
    else
	{
	name = name+1;		/* pointer to first char after last slash */
	}
    
    strcpy(procName, name);
    if (ccsInit(procName, 0, NULL, NULL, &error) == FAILURE)
	{
	fprintf (stderr,"ccsInit failed.\n");
	exit(1);
	}
    
    if (slxParseSetup(argv[1],	/* setup filename */
		      argv[2],	/* slxFITS_CAT  selCategory */
		      argv[3],	/* ccsENVNAME   destEnv */
		      argv[4],	/* ccsPROCNAME  destProc */
		      wait,	/* vltLOGICAL   waitForLastReply */
		      timeout,	/* msgTIMEOUT   timeOut */
		      &pending,	/* vltUINT16    *expReplies */
                      &error) == FAILURE)
    {
	fprintf(stderr,"%s",error.runTimePar);
	exit (1);
    }
    else
    {
	printf("Expected replies = %d", pending);
	exit(0);
    }
}









