/******************************************************************************
* E.S.O. - VLT project
*
* slxTestResolvePath.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* epozna    30/07/02  Created to test VLTSW20000078                     
*/

/************************************************************************
*   NAME
*   slxTestResolvePath - tests the function slxResolvePath()
*
*   SYNOPSIS
*   slxTestResolvePath <path> <expected result>
*
*   DESCRIPTION: 
*   VLTSW20000078 slxResolvePath should result in the the whole path.
*   Eg. declare the full path for:
*               ./file
*               ../mydir/test/../test/ 
*               ./mydir/./test/
*               $INTROOT/
*               ../../mydir/myfile
*               ~/myfile 
*
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h" 

static char *rcsId="@(#) $Id: slxTestResolvePath.c,v 1.145 2005/07/27 12:31:16 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

/* System Headers 
 */
#include <string.h>
/* Local Headers 
 */
#include "slx.h"

/* Main
 */
int main (int argc, char *argv[])
{
    ccsERROR    error;
    char* resolvedPath;
    errResetStack(&error);

    if ((argc < 3) ||  (argc >4) )
        {
        printf("\nSyntax is:\n slxTestResolvePath <path> <result>\n");
        return(1);
        } 
    
    /* resolve path
     */
    if (slxResolvePath(argv[1],&resolvedPath , &error) == FAILURE)
	{
	printf ("could not resolve path\n");
	return FAILURE;
	}

    /* check result
     */
    if(strcmp(resolvedPath,argv[2])!=0)
	{
	printf("PATH (decalred):\n%s\n",resolvedPath);
	printf("PATH (should have been):\n%s\n",argv[2]);
	return(1);
	}

    return(0);
}
