/******************************************************************************
* E.S.O. - VLT project
*
* slxTestSPR2004.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* mnylund   23/10/03  Created 1. version
*/

/************************************************************************
*   NAME
*   slxTestSPR2004 - program to test SPRs included in 2004 release
* 
*   SYNOPSIS
*   slxTestSPR2004
* 
*------------------------------------------------------------------------
*/

#define _POSIX_SOURCE 1
#include "vltPort.h" 


static char *rcsId="@(#) $Id: slxTestSPR2004.c,v 1.145 2005/07/27 12:36:48 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

/* System Headers 
 */
#include <stdio.h>
#include <string.h>

/* Local Headers 
 */
#include "slx.h"

/*********************************************************/
/* SPR20030038 Test the slxGenDayTimBasic rounding error */
/*********************************************************/
void SPR20030038()
{
  unsigned long  tv_sec;
  long           tv_usec;
  vltINT32       precision;
  slxKEYW_LINE   dayTime;

  tv_sec  = 1043842126;
  tv_usec = 999666;

  precision = 0;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 1;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 2;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 3;
  slxGenDayTimBasic(tv_sec, tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 4;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 5;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);

  precision = 6;
  slxGenDayTimBasic(tv_sec,tv_usec,precision,dayTime);    
  printf("%s\n", dayTime);
}

/********************************************************************/
/* SPR20030044 Test of the dangling pointer in slxSplitShortFitsDyn */
/*                                                                  */
/* The test is successful if no error is printed AND if the test    */
/* does not result in a core dump.                                  */
/********************************************************************/
int SPR20030044()
{
  /* ccs variables */
  ccsERROR      error;

  slxKEYW_LINE  shortFitsLine;
  slxKEYW_LINE  keyElements[slxMAX_NO_OF_KEY_ELS];
  vltINT32      noOfKeyElements=0;
  slxVALUE      value;
  slxCOMMENT    comment;

  /* Reset the shortFitsLine */
  memset(shortFitsLine, 0, sizeof(slxKEYW_LINE));

  if (slxSplitShortFitsDyn(shortFitsLine, slxMAX_NO_OF_KEY_ELS, keyElements, 
			   &noOfKeyElements, value, comment, &error) == FAILURE)
    printf("ERROR !!! Not a succesfull test of the SPR20030044\n");

  printf("Successful test of SPR20030044\n");
  return (0);
}

/********/
/* Main */
/****** */
int main(int argc, char *argv[])
{
  SPR20030038();
  SPR20030044();

  return(0);
}





