/*******************************************************************************
* E.S.O. - VLT project
*
* slxTestDynBufReadToCrt.c
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  12/10/95  Created
*/

/************************************************************************
*   NAME
*   slxTestDynBufReadToCrt - load a file and save it afterwards
* 
*   SYNOPSIS
*   slxTestDynBufReadToCrt <env var> <load file> <save file>
* 
*   DESCRIPTION
*
*   ENVIRONMENT
*
*   RETURN VALUES
*
*   EXAMPLES
*
*------------------------------------------------------------------------
*/
#define _POSIX_SOURCE 1
#include "vltPort.h"

static char *rcsId="@(#) $Id: slxTestTemplate.c,v 1.145 2005/07/27 12:10:32 vltsccm Exp $";
static void *use_rcsId = ((void)&use_rcsId,(void *) &rcsId);

/* Local Headers 
 */
#include "slx.h"
#include "slxTest.h"

/* Main
 */
int main (int argc, char *argv[])
{
    char              *chrPtr;
    ccsERROR          error;
    ccsPROCNAME       procName;
    slxDYN_BUF        fileHandle;
    slxDYN_BUF        tempBuf;
    slxFILENAME       loadFile;
    slxFILENAME       saveFile;
    slxKEYW_LINE      inBuf;
    vltINT8           first;
    vltUINT32         bufLen;


    /* Check input parameters
     */
    if (argc < 4)
      {
      printf("\nCorrect syntax is: \n\n");
      printf("slxTestDynBufReadToCrt <env var> <load file> <save file>\n\n");
      exit(1);
      }
    
    strcpy(procName, "slxTestRdBufCrt");
    if (ccsInit(procName, 0, NULL, NULL, &error) == FAILURE)
        {
        printf("\nError in initializing on RTAP!\n\n");
        exit(1);
        }

    slxInitDynBuf(&fileHandle, &error);
    slxInitDynBuf(&tempBuf, &error);

    strcpy(loadFile, argv[2]);
    strcpy(saveFile, argv[3]);

    /* Load the file
     */
    if (slxLoadFile(loadFile, argv[1], &fileHandle, &error) == FAILURE)
	goto errorCond;

    /* Get the lines from the buffer and store them in the tempBuf
     */
    tempBuf.nextPos = tempBuf.prevPos = tempBuf.dynBuf;
    first = 1;
    do
	{
	if (slxDynBufReadToCrt(&fileHandle, &chrPtr, &bufLen, 
			       &error) == FAILURE)
	    goto errorCond;
	if (first)
	    {
	    *inBuf = *(fileHandle.dynBuf);
	    memcpy((inBuf + 1), chrPtr, bufLen);
	    first = 0;
	    }
	else
	    memcpy(inBuf, chrPtr, bufLen);
	/* Append the '\n' again
	 */
	*(inBuf + bufLen) = '\n';
	*(inBuf + bufLen + 1) = '\0';	

	if (slxStoreBufDynBuf(&tempBuf, inBuf, (bufLen+1), &error) == FAILURE)
	    goto errorCond;
	}
    while (bufLen > 0);


    /* Save the contents in the Save File
     */
    if (slxSaveFile(saveFile, argv[1], &tempBuf, &error) == FAILURE)
	goto errorCond;

    slxResetDynBuf(&fileHandle, &error);
    slxResetDynBuf(&tempBuf, &error);  
    ccsExit(&error);
    exit(0);

  errorCond:
    slxDumpError(&error);
    slxResetDynBuf(&fileHandle, &error);
    slxResetDynBuf(&tempBuf, &error);  
    ccsExit(&error);
    exit(1);

}







